/*
 * $B>.3X4[Bg<-@t(BCD-ROM$B8!:w%f!<%F%#%j%F%#!<(B - daijisen
 *
 *	Written by Junn Ohta (ohta@src.ricoh.co.jp), Public Domain.
 */

char	*progname = "daijisen";
char	*version  = "1.0";
char	*date     = "1998/07/20";

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <fcntl.h>
#include <time.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/stat.h>
#ifdef MSDOS
#include <io.h>
#endif
#ifdef UNIX
#include <unistd.h>
#endif

typedef	unsigned char	uchr;

#ifdef INT16
typedef	unsigned char	byte;
typedef	unsigned int	word;
typedef	unsigned long	dword;
#define	FFFFFFFF	0xffffffffL
#endif
#ifdef INT32
typedef	unsigned char	byte;
typedef	unsigned short	word;
typedef	unsigned int	dword;
#define	FFFFFFFF	0xffffffff
#endif

#define	OK		0
#define	ERR		(-1)

#define	TRUE		1
#define	FALSE		0

#ifndef MSDOS
#define	O_BINARY	0
#endif

#define	READ_FIRST	0	/* $B:G=i$N%G!<%?$rFI$`(B		*/
#define	READ_NEXT	1	/* $B<!$N%G!<%?$rFI$`(B		*/

/* $B%f!<%F%#%j%F%#!<4X?t(B */
int	init_util();
word	val();
word	sval();
dword	dval();
dword	sdval();
int	check_util();
int	compare();
int	gethex();

/* $B30;z=hM}(B */
int	add_gaiji();
int	init_gaiji();
int	load_gaiji();
int	dump_gaiji();
uchr	*get_gaiji();

/* $BF|K\8l=hM}(B */
uchr	*tosjis();
int	jc_outchar();
int	jc_outstr();
int	jc_output();
int	jc_reset();

/* $B%m!<%^;z$+$JJQ49(B */
uchr	*rk_getword();
void    rk_yield();
void    rk_yield_doubled();

/* $B%$%s%G%C%/%9%U%!%$%kA`:n(B */
int	idx_open();
int	idx_close();
int	idx_hdrinfo();
int	idx_retrieve();
int	idx_retrieve2();
int	idx_getpage();
int	idx_getlstidx();
int	idx_dumpkey();

/* $B4A;z8!:w(BDN$B%$%s%G%C%/%9%U%!%$%kA`:n(B */
int	dn_open();
int	dn_close();
int	dn_hdrinfo();
int	dn_retrieve();
int	dn_getlstidx();

/* $B4A;z8!:w(BSLS$B%U%!%$%kA`:n(B */
int	sls_open();
int	sls_close();
int	sls_hdrinfo();
int	sls_retrieve();
int	sls_getlstidx();
int	sls_readentry();

/* LST$B%U%!%$%kA`:n(B */
int	lst_open();
int	lst_close();
int	lst_hdrinfo();
int	lst_getentry();
int	lst_readentry();

/* DAT$B%U%!%$%kA`:n(B */
int	dat_open();
int	dat_close();
int	dat_hdrinfo();
int	dat_getentry();
int	dat_dumppage();
int	dat_getpage();

/* INF$B%U%!%$%kA`:n(B */
int	inf_open();
int	inf_close();
int	inf_hdrinfo();
int	inf_dumppage();
int	inf_getpage();

/* DHLINK$B%U%!%$%kA`:n(B */
int	dhl_open();
int	dhl_close();
int	dhl_getentry();

/* $B8eJ}0lCW%$%s%G%C%/%9:n@.(B */
uchr	*normalize();
uchr	*reverse();
uchr	*strpbrkw();
int	make_revidx();

/* $BIt<sL>8!:w(B */
int	bushu_search();

/* $B<g=hM}(B */
void	usage();
int	parse_opt();
int	init_env();
uchr	*mk_path();
uchr	*search_path();
uchr	*getkey();
int	show_inf();
int	cleanup_inf();
int	retrieve();
int	knj_retrieve();
int	showpagedata();
int	keylist();
int	labellist();
int	bushulist();
int	printdata();
int	dump_param();
int	debugproc();
void	onintr();
int	main();

/* ---------- $B%f!<%F%#%j%F%#!<4X?t(B ---------- */

#define	BUFSIZE		4096	/* $B:n6HMQ(Bdatabuf$B$N%5%$%:(B */

uchr	tmp[256];		/* $B%W%m%0%i%`A4BN$G;H$o$l$k:n6HNN0h(B */
uchr	databuf[BUFSIZE];	/* $B%W%m%0%i%`A4BN$G;H$o$l$k:n6HNN0h(B */
int	bigendian;		/* $B%S%C%0%(%s%G%#%"%s$+(B? */

/*
 * init_util - CPU$B$,%S%C%0%(%s%G%#%"%s$+$I$&$+D4$Y$k(B
 */
int
init_util()
{
    dword	dw = 1;

    bigendian = !(*(uchr *)&dw == 0x01);
    return OK;
}

/*
 * val - $B%U%!%$%k$K3JG<$5$l$F$$$?(B2$B%P%$%H%G!<%?$r(B2$B%P%$%H$NCM$K$9$k(B
 */
word
val(w)
word	w;
{
    if (bigendian)
	return (w >> 8) | ((w & 0xff) << 8);
    else
	return w;
}

/*
 * sval - val$B$NJ8;zNsJQ?tHG(B
 */
word
sval(s)
register uchr	*s;
{
    return ((word)s[1] << 8) | (word)s[0];
}

/*
 * dval - $B%U%!%$%k$K3JG<$5$l$F$$$?(B4$B%P%$%H%G!<%?$r(B4$B%P%$%H$NCM$K$9$k(B
 */
dword
dval(dw)
dword	dw;
{
    if (bigendian)
	return (dw >> 24) | (dw >> 16 & 0xff) << 8 |
	    (dw >> 8 & 0xff) << 16 | (dw & 0xff) << 24;
    else
	return dw;
}

/*
 * sdval - dval$B$NJ8;zNsJQ?tHG(B
 */
dword
sdval(s)
register uchr	*s;
{
    return ((dword)s[3] << 24) | ((dword)s[2] << 16) |
	((dword)s[1] << 8) | (dword)s[0];
}

/*
 * compare - $BJ8;zNs$r(Bunsigned char$B$NNs$H$7$FHf3S$9$k(B
 *	     (strncmp$B$d(Bmemcmp$B$G$O(Bsigned$B$GHf3S$5$l$k4D6-$,$"$k(B)
 */
int
compare(s1, s2, len)
register uchr	*s1, *s2;
size_t		len;
{
    while (*s1 && *s2 && len-- > 0) {
	if (*s1 < *s2)
	    return -1;
	if (*s1 > *s2)
	    return 1;
	s1++;
	s2++;
    }
    if (len == 0)
	return 0;
    if (*s1)
	return 1;
    if (*s2)
	return -1;
    return 0;
}

/*
 * gethex - $BJ8;zNs$X$N%]%$%s%?!<$r<u$1<h$j!"@hF,$K$"$k(B2$B7e$N(B16$B?J?t$N(B
 *	    $BCM$rJV$9!#%]%$%s%?!<$O(B2$B%P%$%H?J$a$i$l$k(B
 */
int
gethex(pp)
register uchr	**pp;
{
    register int c;
    int		n;

    c = *(*pp)++;
    if (c >= '0' && c <= '9')
	n = c - '0';
    else if (c >= 'a' && c <= 'f')
	n = c - 'a' + 10;
    else if (c >= 'A' && c <= 'F')
	n = c - 'A' + 10;
    else
	return ERR;
    n <<= 4;
    c = *(*pp)++;
    if (c >= '0' && c <= '9')
	n += c - '0';
    else if (c >= 'a' && c <= 'f')
	n += c - 'a' + 10;
    else if (c >= 'A' && c <= 'F')
	n += c - 'A' + 10;
    else
	return ERR;
    return n;
}

/* ---------- $B30;z=hM}(B ---------- */

/*
 * $BI8=`$N30;z%G!<%?(B
 */
uchr	*stdgaiji[] = {
    "f0b8	kg",			/* $B%-%m%0%i%`(B */
    "f0b9	cc",			/* $B%7!<%7!<(B */
    "f0cb	$B!J8x!K(B",		/* $B!{$K8x(B */
    "f0d0	$B!"(B",			/* $BFIE@(B */
    "f0dc	I",			/* $B%m!<%^?t;z$N(B1 */
    "f0dd	II",			/* $B%m!<%^?t;z$N(B2 */
    "f0e8	III",			/* $B%m!<%^?t;z$N(B3 */
    "f0e9	IV",			/* $B%m!<%^?t;z$N(B4 */
    "f0ea	V",			/* $B%m!<%^?t;z$N(B5 */
    "f0ed	VIII",			/* $B%m!<%^?t;z$N(B8 */
    "f0ee	X",			/* $B%m!<%^?t;z$N(B10 */
    "f0f7	$B"i(B",			/* $B@QJ,5-9f(B */
    "f15b	$B!J%1!K(B",		/* $B!{$K%1(B */
    "f15c	$B!J%3!K(B",		/* $B!{$K%3(B */
    "f15d	$B!J%5!K(B",		/* $B!{$K%5(B */
    "f15e	$B!J%7!K(B",		/* $B!{$K%7(B */
    "f15f	$B!J%9!K(B",		/* $B!{$K%9(B */
    "f160	$B!J%;!K(B",		/* $B!{$K%;(B */
    "f176	$B!m(B",			/* $BIC5-9f(B */
    "f182	$B!JHk!K(B",		/* $B!{$KHk(B */
    "f1bb	$B"N(B",			/* $B"+"*(B */
    "f1cd	$B!&(B",			/* $BGrH4$-$NCfE@(B($BH>ByE@$H6&MQ(B) */
    "f1d6	[h-]",			/* h$B$K2#K@(B */
    "f1ec	$B!"(B",			/* $BFIE@$G$O$J$/K5E@(B */
    "f1ed	[$B%$!&(B]",		/* $B%$$N>e$K!&(B */
    "f1ee	[$B>e2<5U$N&8(B]",		/* $B%b!<(B */
    "f24f	$B%+!,(B",			/* $B%+$KH>By2;(B */
    "f250	$B%1!,(B",			/* $B%1$KH>By2;(B */
    "f25c	$B!J#C!K(B",		/* $B!{$K(BC */
    "f25d	$B!J#a!K(B",		/* $B!{$K(Ba */
    "f25e	$B!J#b!K(B",		/* $B!{$K(Bb */
    "f25f	$B!J#c!K(B",		/* $B!{$K(Bc */
    "f299	$B!J%"!K(B",		/* $B!{$K%"(B */
    "f29a	$B!J%$!K(B",		/* $B!{$K%$(B */
    "f29b	$B!J%&!K(B",		/* $B!{$K%&(B */
    "f29c	$B!J%(!K(B",		/* $B!{$K%((B */
    "f29d	$B!J%*!K(B",		/* $B!{$K%*(B */
    "f29e	$B!J%+!K(B",		/* $B!{$K%+(B */
    "f29f	$B!J%-!K(B",		/* $B!{$K%-(B */
    "f2a0	$B!J%/!K(B",		/* $B!{$K%/(B */
    "f2a1	$B!J0l!K(B",		/* $B!{$K0l(B */
    "f2a2	$B!JFs!K(B",		/* $B!{$KFs(B */
    "f2a3	$B!J;0!K(B",		/* $B!{$K;0(B */
    "f2a4	$B!J;M!K(B",		/* $B!{$K;M(B */
    "f361	$B"M(B",			/* $BGrH4$-$N"*(B */
    "f4a6	$B!1(B",
    "f4ae	$B!Z(B",			/* $BGrH4$-$N!Z(B */
    "f4af	$B![(B",			/* $BGrH4$-$N![(B */
    "f4b2	$B!+(B",
    "f4b3	$B!&(B",			/* $BGrH4$-$NCfE@(B($BH>ByE@$H6&MQ(B) */
    "f4bd	g",
    "f787	$B!R0l!S(B",		/* $BGrH4$-$N!{0l(B */
    "f788	$B!RFs!S(B",		/* $BGrH4$-$N!{Fs(B */
    "f789	$B!R;0!S(B",		/* $BGrH4$-$N!{;0(B */
    "f78a	$B!R;M!S(B",		/* $BGrH4$-$N!{;M(B */
    "f78c	$B!L#1!M(B",
    "f78d	$B!L#2!M(B",
    "f78e	$B!L#3!M(B",
    "f78f	$B!L#4!M(B",
    "f790	$B!L#5!M(B",
    "f791	$B!L#6!M(B",
    "f792	$B!L#7!M(B",
    "f793	$B!L#8!M(B",
    "f794	$B!L#9!M(B",
    "f795	$B!L(B10$B!M(B",
    "f796	$B!L(B11$B!M(B",
    "f797	$B!L(B12$B!M(B",
    "f798	$B!L(B13$B!M(B",
    "f799	$B!L(B14$B!M(B",
    "f79a	$B!L(B15$B!M(B",
    "f79b	$B!L(B16$B!M(B",
    "f79c	$B!L(B17$B!M(B",
    "f79d	$B!L(B18$B!M(B",
    "f79e	$B!L(B19$B!M(B",
    "f79f	$B!L(B20$B!M(B",
    "f7a0	$B!L(B21$B!M(B",
    "f7a1	$B!L(B22$B!M(B",
    "f7a2	$B!L(B23$B!M(B",
    "f7a3	$B!L(B24$B!M(B",
    "f7a4	$B!L(B25$B!M(B",
    "f7a7	[$B"((B]",			/* $B%@%k%;!<%K%g(B:-) */
    "f7a8	$B!L0l!M(B",
    "f7a9	$B!LFs!M(B",
    "f7aa	$B!L;0!M(B",
    "f7ab	$B!L;M!M(B",
    "f7ac	$B!L8^!M(B",
    "f7ae	$B!N0l!O(B",		/* $BGrH4$-$N!L0l!M(B */
    "f7af	$B!NFs!O(B",		/* $BGrH4$-$N!LFs!M(B */
    "f7b0	$B!N;0!O(B",		/* $BGrH4$-$N!L;0!M(B */
    "f7b1	$B!N;M!O(B",		/* $BGrH4$-$N!L;M!M(B */
    "f7b2	$B!N8^!O(B",		/* $BGrH4$-$N!L8^!M(B */
    "f7b3	$B!LO;!M(B",
    "f7b4	$B!L<7!M(B",
    "f7b5	$B!LH,!M(B",
    "f7b7	$B!L(B26$B!M(B",
    "f7b8	$B!L(B27$B!M(B",
    "f7b9	$B!L(B28$B!M(B",
    "f7ba	$B!L(B29$B!M(B",
    "f7bb	$B!L(B30$B!M(B",
    "f7bc	$B!L(B31$B!M(B",
    "f7bd	$B!L(B32$B!M(B",
    "f7cb	[$B!&!0(B]",		/* $B%U%'%k%^!<%?(B:-) */
    "f7cc	$B!LJ8!M(B",
    "f7d7	[$B"u"u(B]",		/* $B%@%V%k%U%i%C%H(B */
    "f7d8	$B!RO;!S(B",		/* $BGrH4$-$N!{O;(B */
    "f7d9	$B!NO;!O(B",		/* $BGrH4$-$N!LO;!M(B */
    "f7da	$B!L?^HG!M(B",
    "f7db	$B!LF02h!M(B",
    "f7dc	$B!LF02h(B/$B2;@<!M(B",
    "f7dd	$B!L=q$-=g!M(B",
    "f7df	$B!L?'8+K\!M(B",
    "f7e1	[a$B!/(B]",
    "f7e2	[o$B!/(B]",
    "f7e3	[u$B!/(B]",
    "f7e4	[$B$"!&(B]",
    "f7e5	[$B$-!&(B]",
    "f7e6	[$B$3!1(B]",
    "f7e7	[$B$8!1(B]",
    "f7e8	[$B$:!1(B]",
    "f7e9	[$B$;!&(B]",
    "f7ea	[$B$?!&(B]",
    "f7eb	[$B$N!1(B]",
    "f7ec	[$B$O!&(B]",
    "f7ed	[$B$b!1(B]",
    "f7ee	[s,]",
    "f7ef	[c,]",
    "f7f0	[sz]",			/* $B%(%9%D%'%C%H(B */
    "f7f1	[AE]",
    "f7f2	[ae]",
    "f7f3	[oe]",
    "f7f4	 I",
    "f7f5	 II",
    "f7fb	 V",
    "f7fc	[o]",			/* $B:83+$-$N(Bo */
    "f840	[sh]",
    "f841	[a+o]",			/* $B$H$5$+$N$J$$(Ba */
    "f842	[:]",			/* $BH/2;5-9f$ND92;(B */
    "f843	[g]",
    "f844	[ng]",
    "f845	[zj]",
    "f846	[o/]",			/* o$B$K<P@~(B */
    "f847	[n]",			/* $B:8B-$K$R$2(B */
    "f848	[f]",			/* $B>e2<5U$N(Bf */
    "f849	[l/]",			/* l$B$K<P@~(B */
    "f84a	[L/]",			/* L$B$K<P@~(B */
    "f84b	[l/]",			/* l$B$K<P@~(B */
    "f84c	[ac]",			/* a$B$N2<$K(Bc$B7A$N$R$2(B */
    "f84d	[ec]",			/* e$B$N2<$K(Bc$B7A$N$R$2(B */
    "f84e	[$B&5(B]",
    "f84f	[$B"*"+(B]",		/* $B>e$K"*!"2<$K"+(B */
    "f850	[o/]",			/* o$B$K<P@~(B */
    "f851	3$B"e(B",			/* $BN)J}:,9f(B */
    "f852	n$B"e(B",			/* n$B>h:,9f(B */
    "f853	$B"e(B",			/* $BJ?J}:,9f(B */
    "f854	[HP]",			/* HP$B$N$/$C$D$$$?7A(B */
    "f856	[-+]",			/* $B>e$K(B-$B!"2<$K(B+ */
    "f857	$B"e(B2",			/* $BJ?J}:,9f$K(B2 */
    "f858	$B"e(Ba",			/* $BJ?J}:,9f$K(Ba */
    "f85a	$B"<(B",			/* $BItJ,=89g5-9f(B */
    "f85b	$B&$(B",
    "f85c	$B&+(B",
    "f85d	$B&0(B",
    "f85e	$B&2(B",
    "f85f	$B&5(B",
    "f860	$B&8(B",
    "f861	$B&A(B",
    "f862	$B&B(B",
    "f863	$B&C(B",
    "f864	$B&H(B",
    "f865	$B&K(B",
    "f866	$B&L(B",
    "f867	$B&P(B",
    "f868	[o/]",			/* o$B$K<P@~(B */
    "f869	[uu$B!/(B]",
    "f86a	[i$B!1(B]",
    "f86b	[i$B!-(B]",
    "f86c	[i$B!/(B]",
    "f86d	[i^]",
    "f86e	[A$B!0(BB]",		/* AB$B$r$*$*$&$h$&$K!0(B */
    "f86f	[AB$B"*(B]",		/* AB$B$r$*$*$&$h$&$K"*(B */
    "f870	[a$B"*(B]",			/* a$B$N>e$K"*(B */
    "f871	[b$B"*(B]",			/* b$B$N>e$K"*(B */
    "f872	[3$B!&(B]",			/* 3$B$N>e$K!&(B */
    "f873	[5$B!&(B]",			/* 5$B$N>e$K!&(B */
    "f874	$B"r(B",			/* $B%*%s%0%9%H%m!<%`(B */
    "f875	[A$B!1(B]",
    "f876	[A$B!-(B]",
    "f877	[A$B!.(B]",
    "f878	[A$B!/(B]",
    "f879	[C$B"K(B]",			/* C$B$N>e$K5U!0(B */
    "f87a	[D.]",
    "f87b	[E$B!1(B]",
    "f87c	[E$B!-(B]",
    "f87d	[E$B"K(B]",			/* E$B$N>e$K5U!0(B */
    "f87e	[H.]",
    "f880	[I$B!&(B]",			/* I$B$N>e$K!&(B */
    "f881	[I$B!1(B]",
    "f882	[O$B!1(B]",
    "f883	[O$B!/(B]",
    "f884	[R.]",
    "f885	[S.]",
    "f886	[S$B!-(B]",
    "f887	[U$B!1(B]",
    "f888	[U$B!/(B]",
    "f889	[Z.]",
    "f88a	[a$B!,(B]",
    "f88b	[a$B!-(B.]",
    "f88c	[a$B!1(B]",
    "f88d	[a$B!A(B]",
    "f88e	[a$B!-(B]",
    "f88f	[a$B!.(B]",
    "f890	[a$B!/(B]",
    "f891	[a^]",
    "f892	[b.]",
    "f893	[c$B"K(B]",			/* c$B$N>e$K5U!0(B */
    "f894	[c$B!1(B]",
    "f895	[c$B!-(B]",
    "f896	[d.]",
    "f897	[e$B"K(B]",
    "f898	[e$B!1(B]",
    "f899	[e$B!-(B]",
    "f89a	[e$B!.(B]",
    "f89b	[e$B!/(B]",
    "f89c	[e^]",
    "f89d	[h.]",
    "f89e	[i$B!&(B]",			/* i$B$N>e$K!&(B */
    "f89f	[i$B!1(B]",
    "f8a0	[i$B!-(B]",
    "f8a1	[i$B!/(B]",
    "f8a2	[i^]",
    "f8a3	[k.]",
    "f8a4	[m$B!&(B]",			/* m$B$N>e$K!&(B */
    "f8a5	[m.]",
    "f8a6	[n$B"K(B]",			/* n$B$N>e$K5U!0(B */
    "f8a7	[n$B!&(B]",			/* n$B$N>e$K!&(B */
    "f8a8	[n.]",
    "f8a9	[n$B!A(B]",
    "f8aa	[n$B!-(B]",
    "f8ab	[o$B!1(B]",
    "f8ac	[o$B!A(B]",
    "f8ad	[o$B!-(B]",
    "f8ae	[o$B!.(B]",
    "f8af	[o$B!/(B]",
    "f8b0	[o^]",
    "f8b1	[r$B"K(B]",			/* r$B$N>e$K5U!0(B */
    "f8b2	[r.]",
    "f8b3	[s$B"K(B]",			/* s$B$N>e$K5U!0(B */
    "f8b4	[s.]",
    "f8b5	[s$B!-(B]",
    "f8b6	[t|]",
    "f8b7	[u$B!1(B]",
    "f8b8	[u$B!-(B]",
    "f8b9	[u$B!.(B]",
    "f8ba	[u$B!/(B]",
    "f8bb	[u^]",
    "f8bc	[y$B!/(B]",
    "f8bd	[z$B"K(B]",			/* z$B$N>e$K5U!0(B */
    "f8be	[z.]",
    "f8bf	[z$B!-(B]",
    NULL
};

uchr	*gaijitbl[9][192];	/* 0xf0$B!A(B0xf8 + 0x40$B!A(B0xff */
uchr	*gaijifile = NULL;	/* $B30;z%G!<%?$r3JG<$7$?%U%!%$%k(B */

/*
 * add_gaiji - 1$B$D$N30;z%G!<%?$r30;zI=$KDI2C$9$k(B
 *	       $BF1$8%3!<%I$N30;z%G!<%?$,$"$l$P>e=q$-$5$l$k(B
 */
int
add_gaiji(str)
uchr	*str;
{
    int		n1, n2;

    if (str == NULL)
	return ERR;
    if ((n1 = gethex(&str)) == ERR)
	return ERR;
    if ((n2 = gethex(&str)) == ERR)
	return ERR;
    if (n1 < 0xf0 || n1 > 0xf8 || n2 < 0x40)
	return ERR;
    if (*str != ' ' && *str != '\t')
	return ERR;
    str++;
    n1 -= 0xf0;
    n2 -= 0x40;
    if (gaijitbl[n1][n2] != NULL)
	free((char *)gaijitbl[n1][n2]);
    gaijitbl[n1][n2] = strdup(str);
    return OK;
}

/*
 * init_gaiji - $BI8=`$N30;z%G!<%?$G30;zI=$r=i4|2=$9$k(B
 */
int
init_gaiji()
{
    uchr	**pp;

    for (pp = stdgaiji; *pp; pp++) {
	if (add_gaiji(*pp) != OK)
	    return ERR;
    }
    return OK;
}

/*
 * load_gaiji - gaijifile$B$K%U%!%$%kL>$,@_Dj$5$l$F$$$?$i(B
 *		$B$=$N%U%!%$%k$+$i30;z%G!<%?$r30;zI=$K%m!<%I$9$k(B
 */
int
load_gaiji()
{
    int		n, err;
    FILE	*fp;
    uchr	*p, buf[128];

    if (gaijifile == NULL)
	return OK;
    if ((fp = fopen(gaijifile, "r")) == NULL) {
	sprintf(tmp, "%s: $B30;z%U%!%$%k(B %s $B$,%*!<%W%s$G$-$^$;$s(B\n",
	    progname, gaijifile);
	jc_outstr(tmp);
	return ERR;
    }
    n = 0;
    err = 0;
    while (fgets(buf, 128, fp) != NULL) {
	n++;
	p = buf;
	if (*p == '\0' || *p == '\n' || *p == ';')
	    continue;
	while (*p && *p != ' ' && *p != '\t')
	    p++;
	p++;
	while (*p && *p != '\t' && *p != '\n')
	    p++;
	*p = '\0';
	if (add_gaiji(buf) != OK) {
	    sprintf(tmp, "%s: $B30;z%U%!%$%k(B %s $B$N(B%d$B9T$a$K%(%i!<$,$"$j$^$9(B\n",
		progname, gaijifile, n);
	    jc_outstr(tmp);
	    err++;
	}
    }
    fclose(fp);
    return (err > 0)? ERR: OK;
}

/*
 * dump_gaiji - $B30;zI=$NFbMF$r%@%s%W$9$k(B
 */
int
dump_gaiji()
{
    int		n1, n2;
    uchr	*p;

    jc_outstr("$B!T30;zI=!U(B\n");
    for (n1 = 0; n1 < 9; n1++) {
	for (n2 = 0; n2 < 192; n2++) {
	    if (gaijitbl[n1][n2] != NULL) {
		sprintf(tmp, "%02x%02x	%s\n",
		    n1 + 0xf0, n2 + 0x40, gaijitbl[n1][n2]);
		jc_outstr(tmp);
	    }
	}
    }
    printf("\n");
    return OK;
}

/*
 * get_gaiji - 2$B%P%$%H$NCM$KBP1~$9$k30;z%G!<%?$rJ8;zNs$H$7$FJV$9(B
 *	       $B30;z$,L$Dj5A$J$i(B [xxyy] $B$NJ8;zNs$r:n$C$FJV$9(B
 */
uchr *
get_gaiji(n1, n2)
int	n1, n2;
{
    static uchr	buf[16];

    if (n1 < 0xf0 || n1 > 0xf8 || n2 < 0x40 ||
	    gaijitbl[n1 - 0xf0][n2 - 0x40] == NULL) {
	sprintf(buf, "[%02x%02x]", n1, n2);
	return buf;
    }
    return gaijitbl[n1 - 0xf0][n2 - 0x40];
}

/* ---------- $BF|K\8l=hM}(B ---------- */

#define	KC_JIS		0
#define	KC_EUC		1
#define	KC_SJIS		2

#ifdef MSDOS
#define	KC_DEF		KC_SJIS
#endif
#ifdef UNIX
#define	KC_DEF		KC_EUC
#endif

int	kcode = KC_DEF;		/* $BF~=PNO4A;z%3!<%I(B		*/
int	jiskanji = 'B';		/* JIS$B4A;z%3!<%I$N4A;zA*Br(B	*/
int	jisalpha = 'B';		/* JIS$B4A;z%3!<%I$N1Q;zA*Br(B	*/
int	width = 0;		/* $B=PNO9TI}(B			*/
int	kmode = FALSE;		/* $BC<Kv$,(BJIS$B4A;z;X<(>uBV$+(B?	*/

/*
 * tosjis - kcode$B$GI=8=$5$l$?J8;zNs$r%7%U%H(BJIS$B$KJQ49$9$k(B
 *	    ($B%3%^%s%I9T0z?t$NJQ49$K;H$&(B)
 */
uchr *
tosjis(str)
uchr	*str;
{
    register int c, c1;
    int		c2, km;
    uchr	*p;
    static uchr	buf[128];

    if (kcode == KC_SJIS) {
	strcpy((char *)buf, str);
	return buf;
    }
    km = FALSE;
    p = buf;
    c1 = 0;
    while ((c = *str++) != '\0') {
	if (c1 != 0) {
	    c1 &= 0x7f;
	    c &= 0x7f;
	    if ((c1 & 0x01) == 0) {
		c += 0x7e;
	    } else {
		c += 0x1f;
		if (c > 0x7e)
		    c++;
	    }
	    c1 = (c1 + 0xe1) >> 1;
	    if (c1 > 0x9f)
		c1 += 0x40;
	    *p++ = c1;
	    *p++ = c;
	    c1 = 0;
	    continue;
	}
	if (c == '\033') {
	    c1 = *str++;
	    c2 = *str++;
	    if (c1 == '$' && (c2 == '@' || c2 == 'B'))
		km = TRUE;
	    else if (c1 == '(' && (c2 == 'J' || c2 == 'B'))
		km = FALSE;
	    continue;
	}
	if ((c & 0x80) || km == 1) {
	    c1 = c;
	    continue;
	}
	*p++ = c;
    }
    *p = '\0';
    return buf;
}

/*
 * jc_outchar - $B%7%U%H(BJIS$B$NJ8;z$r>uBVA+0\$r4IM}$7$J$,$i(B
 *		kcode$B$KJQ49$7$F=PNO$9$k(B
 *		$B0z?t$,(B0$B$J$i=PNOB&$N>uBV$r1Q;z$KLa$9(B(JIS$B$N$H$-I,MW(B)
 */
int
jc_outchar(c)
int	c;
{
    static int	knj1 = 0;

    if (c == '\0') {
	if (kmode) {
	    printf("\033(%c", jisalpha);
	    kmode = FALSE;
	}
	return OK;
    }
    if (knj1 != 0) {
	if (kcode == KC_JIS && !kmode) {
	    printf("\033$%c", jiskanji);
	    kmode = TRUE;
	}
	if (kcode == KC_JIS || kcode == KC_EUC) {
	    if (knj1 > 0x9f)
		knj1 -= 0x40;
	    knj1 += knj1;
	    if (c <= 0x9e) {
		knj1 -= 0xe1;
		if (c >= 0x80)
		    c -= 1;
		c -= 0x1f;
	    } else {
		knj1 -= 0xe0;
		c -= 0x7e;
	    }
	    if (kcode == KC_EUC) {
		knj1 += 0x80;
		c += 0x80;
	    }
	}
	putchar(knj1);
	putchar(c);
	knj1 = 0;
	return OK;
    }
    if (c >= 0x81) {
	knj1 = c;
	return OK;
    }
    if (kmode) {
	printf("\033(%c", jisalpha);
	kmode = FALSE;
    }
    putchar(c);
    return OK;
}

/*
 * jc_outstr - $B30;z$rJQ49$7$J$,$i(Bjc_outchar$B7PM3$GJ8;z$r=PNO$9$k(B
 */
int
jc_outstr(str)
uchr	*str;
{
    int		c;
    uchr	*gstr;

    if (str == NULL)
	return ERR;
    while (*str) {
	if (*str >= 0xf0) {
	    gstr = get_gaiji(str[0], str[1]);
	    while (*gstr)
		jc_outchar(*gstr++);
	    str += 2;
	    continue;
	}
	if (*str >= 0x81) {
	    jc_outchar(*str++);
	    jc_outchar(*str++);
	    continue;
	}
	jc_outchar(*str++);
    }
    jc_outchar(0);
    return OK;
}

/*
 * jc_output - $B=PNO9TI}$r4IM}$7$J$,$i(Bjc_outchar$B7PM3$GJ8;z$r=PNO$9$k(B
 *	       $B30;z$NJQ49$O$3$3$G$b9T$o$l$k(B
 */
int
jc_output(str)
uchr	*str;
{
    int		n, pos;
    uchr	*gstr;

    if (str == NULL)
	return ERR;
    pos = 0;
    while (*str) {
	if (*str >= 0xf0) {
	    gstr = get_gaiji(str[0], str[1]);
	    n = strlen(gstr);
	    if (width > 0 && pos + n > width) {
		jc_outchar('\n');
		pos = 0;
	    }
	    jc_outstr(gstr);
	    str += 2;
	    pos += n;
	    continue;
	}
	if (*str >= 0x81) {
	    if (width > 0 && pos + 2 > width) {
		jc_outchar('\n');
		pos = 0;
	    }
	    jc_outchar(*str++);
	    jc_outchar(*str++);
	    pos += 2;
	    continue;
	}
	if (*str == '\n') {
	    jc_outchar(*str++);
	    pos = 0;
	    continue;
	}
	if (width > 0 && pos >= width) {
	    jc_outchar('\n');
	    pos = 0;
	}
	jc_outchar(*str++);
	pos++;
    }
    jc_outchar(0);
    return OK;
}

/*
 * jc_reset - $BC<KvB&$NJ8;z%3!<%IA+0\>uBV$r1Q;z$KLa$9(B
 */
int
jc_reset()
{
    jc_outchar(0);
    return OK;
}

/* ---------- $B%m!<%^;z$+$JJQ49(B ---------- */

int	rk_ctable[] = {
 /* a  b  c  d e f g  h i j k l  m  n o  p q  r  s  t u v  w  x  y  z */
    0,25,15,15,3,0,5,25,1,0,5,0,30,20,4,25,0,40,10,15,2,0,45,50,35,10
};

int	rk_offset[] = {
 /* a b c d e f g h i j k l m n o p q r s t u v w x y z */
    0,1,0,1,0,0,1,0,0,0,0,0,0,0,0,2,0,0,0,0,0,1,0,0,0,1
};

uchr	*rk_hstr[] = {
    "$B$"(B","$B$$(B","$B$&(B","$B$((B","$B$*(B","$B$+(B","$B$-(B","$B$/(B","$B$1(B","$B$3(B",
    "$B$5(B","$B$7(B","$B$9(B","$B$;(B","$B$=(B","$B$?(B","$B$A(B","$B$D(B","$B$F(B","$B$H(B",
    "$B$J(B","$B$K(B","$B$L(B","$B$M(B","$B$N(B","$B$O(B","$B$R(B","$B$U(B","$B$X(B","$B$[(B",
    "$B$^(B","$B$_(B","$B$`(B","$B$a(B","$B$b(B","$B$d(B","$B$$(B","$B$f(B","$B$((B","$B$h(B",
    "$B$i(B","$B$j(B","$B$k(B","$B$l(B","$B$m(B","$B$o(B","$B$p(B","$B$&(B","$B$q(B","$B$r(B","$B$s(B"
};

uchr	*rk_kstr[] = {
    "$B%"(B","$B%$(B","$B%&(B","$B%((B","$B%*(B","$B%+(B","$B%-(B","$B%/(B","$B%1(B","$B%3(B",
    "$B%5(B","$B%7(B","$B%9(B","$B%;(B","$B%=(B","$B%?(B","$B%A(B","$B%D(B","$B%F(B","$B%H(B",
    "$B%J(B","$B%K(B","$B%L(B","$B%M(B","$B%N(B","$B%O(B","$B%R(B","$B%U(B","$B%X(B","$B%[(B",
    "$B%^(B","$B%_(B","$B%`(B","$B%a(B","$B%b(B","$B%d(B","$B%$(B","$B%f(B","$B%((B","$B%h(B",
    "$B%i(B","$B%j(B","$B%k(B","$B%l(B","$B%m(B","$B%o(B","$B%p(B","$B%&(B","$B%q(B","$B%r(B","$B%s(B"
};

uchr	**rk_str = rk_hstr;

/*
 * rk_getword - $BJ8;zNs0z?t$r%m!<%^;z$+$JJQ49$7$F7k2L$rJ8;zNs$GJV$9(B
 *		$B!&JV$5$l$kJ8;zNs$O(B2$B%P%$%HJ8;z$N$_$+$i$J$k(B
 *		$B!&J8;zNs0z?t$K4^$^$l$k(B2$B%P%$%HJ8;z$O$=$N$^$^DL2a$9$k(B
 *		$B!&(B/$B$,8=$l$k$4$H$K$R$i$,$J!"%+%?%+%J$,@Z$jBX$o$k(B
 *		$B!&(BA$B!A(BZ$B$O1Q;z$K$J$k(B
 *		$B!&!V(B.kmmnn$B!W!V(B.jxxyy$B!W!V(B.sxxyy$B!W$O$=$l$>$l(B
 *		  $B6hE@%3!<%I!"(BJIS$B%3!<%I!"%7%U%H(BJIS$B%3!<%I$N4A;z$K$J$k(B
 */
uchr *
rk_getword(str)
uchr	*str;
{
    int		consonant, small;
    int		c1, c2;
    uchr	*p, *s;
    static uchr	buf[128];

    if (str == NULL)
	return NULL;
    rk_str = rk_hstr;
    s = str;
    p = buf;
    while (*s) {
	if (*s == '/') {
	    /*
	     * $B$R$i$,$J%+%?%+%J@Z$jBX$((B
	     */
	    rk_str = (rk_str == rk_hstr)? rk_kstr: rk_hstr;
	    s++;
	    continue;
	}
	if (*s == '.') {
	    /*
	     * 2$B%P%$%HJ8;z$N%3!<%IF~NO(B
	     */
	    s++;
	    switch (*s++) {
	    case 'K':
	    case 'k':
		if (!isdigit(s[0]) || !isdigit(s[1]) ||
		    !isdigit(s[2]) || !isdigit(s[3]))
		    return NULL;
		c1 = c2 = 0x20;
		c1 += (*s++ - '0') * 10;
		c1 += (*s++ - '0');
		c2 += (*s++ - '0') * 10;
		c2 += (*s++ - '0');
		goto jtos;
	    case 'J':
	    case 'j':
		c1 = gethex(&s);
		c2 = gethex(&s);
	    jtos:
		if (c1 < 0x21 || c1 > 0x7e || c2 < 0x21 || c2 > 0x7e)
		    return NULL;
		if ((c1 & 0x01) == 0) {
		    c2 += 0x7e;
		} else {
		    c2 += 0x1f;
		    if (c2 > 0x7e)
			c2++;
		}
		c1 = (c1 + 0xe1) >> 1;
		if (c1 > 0x9f)
		    c1 += 0x40;
		break;
	    case 'S':
	    case 's':
		c1 = gethex(&s);
		c2 = gethex(&s);
		if (c1 == ERR || c2 == ERR)
		    return NULL;
		break;
	    default:
		return NULL;
	    }
	    *p++ = c1;
	    *p++ = c2;
	    continue;
	}
	if (*s >= 0x81 && *s <= 0x9f || *s >= 0xe0 && *s <= 0xfc) {
	    /*
	     * 2$B%P%$%HJ8;z$ND>@\F~NO(B
	     */
	    *p++ = *s++;
	    *p++ = *s++;
	    continue;
	}
	if (*s >= 'A' && *s <= 'Z') {
	    /*
	     * 2$B%P%$%H1Q;z$X$NJQ49(B
	     */
	    *p++ = 0x82;
	    *p++ = 0x60 + (*s - 'A');
	    s++;
	    continue;
	}
	/*
	 * $B%m!<%^;z$+$JJQ49(B
	 */
	consonant = 0;
	small = 0;
	while (*s > 0 && *s < 0x81) {
	    if (*s >= 'A' && *s <= 'Z' || *s == '/' || *s == '.')
		break;
	    switch (*s) {
	    case 'a':
	    case 'i':
	    case 'u':
	    case 'e':
	    case 'o':
		if (consonant == 'y' && *s == 'e' && small == 0) {
		    rk_yield(&p, 0, 'i', 0);
		    rk_yield(&p, 0, 'e', 1);
		    consonant = 0;
		    break;
		}
		rk_yield(&p, consonant, *s, small);
		consonant = 0;
		small = 0;
		break;
	    case 'k':
	    case 'g':
	    case 't':
	    case 'd':
	    case 'c':
	    case 'n':
	    case 'b':
	    case 'p':
	    case 'm':
	    case 'r':
		rk_yield_doubled(&p, consonant);
		consonant = *s;
		break;
	    case 'j':
		rk_yield_doubled(&p, consonant);
		rk_yield(&p, 'z', 'i', 0);
		consonant = 'y';
		small = 1;
		break;
	    case 'f':
		rk_yield_doubled(&p, consonant);
		rk_yield(&p, 'h', 'u', 0);
		consonant = 0;
		small = 2;
		break;
	    case 'v':
		rk_yield_doubled(&p, consonant);
		*p++ = 0x83; /* vu */
		*p++ = 0x94;
		consonant = 0;
		small = 2;
		break;
	    case 'h':
		if (consonant == 's' || consonant == 'c') {
		    rk_yield(&p, consonant, 'i', 0);
		    consonant = 'y';
		    small = 1;
		    break;
		}
		if (consonant == 't' || consonant == 'd') {
		    rk_yield(&p, consonant, 'e', 0);
		    consonant = 'y';
		    small = 3;
		    break;
		}
		if (consonant == 'w') {
		    rk_yield(&p, consonant, 'u', 0);
		    consonant = 0;
		    small = 2;
		    break;
		}
		rk_yield_doubled(&p, consonant);
		consonant = *s;
		break;
	    case 's':
		if (consonant == 't') {
		    rk_yield(&p, consonant, 'u', 0);
		    consonant = 0;
		    small = 2;
		    break;
		}
		rk_yield_doubled(&p, consonant);
		consonant = *s;
		break;
	    case 'z':
		if (consonant == 'd') {
		    rk_yield(&p, consonant, 'u', 0);
		    consonant = 0;
		    small = 2;
		    break;
		}
		rk_yield_doubled(&p, consonant);
		consonant = *s;
		break;
	    case 'y':
		if (consonant) {
		    rk_yield(&p, consonant, 'i', 0);
		    consonant = 'y';
		    small = 1;
		    break;
		}
		rk_yield_doubled(&p, consonant);
		consonant = *s;
		break;
	    case 'w':
		if (consonant == 't' || consonant == 'd') {
		    rk_yield(&p, consonant, 'o', 0);
		    consonant = 0;
		    small = 4;
		    break;
		}
		if (consonant) {
		    rk_yield(&p, consonant, 'u', 0);
		    consonant = 'w';
		    small = 2;
		    break;
		}
		rk_yield_doubled(&p, consonant);
		consonant = *s;
		break;
	    case 'l':
	    case 'x':
		consonant = 0;
		small = -1;
		break;
	    case '-':
		rk_yield_doubled(&p, consonant);
		*p++ = 0x81; /* chouon */
		*p++ = 0x5b;
		consonant = 0;
		break;
	    case '\'':
	    default:
		rk_yield_doubled(&p, consonant);
		consonant = 0;
		break;
	    }
	    s++;
	}
	if (consonant)
	    rk_yield_doubled(&p, consonant);
    }
    *p = '\0';
    return buf;
}

/*
 * rk_yield - $BFbIt>uBV$+$i$+$JJ8;z$r@8@.$9$k(B
 */
void
rk_yield(pp, consonant, vowel, small)
uchr	**pp;
int	consonant, vowel, small;
{
    int		n, off;

    if (small == 1 && vowel == 'i' ||
	small == 2 && vowel == 'u' ||
	small == 3 && vowel == 'e' ||
	small == 4 && vowel == 'o')
	return;
    if (consonant) {
	n = rk_ctable[vowel - 'a'] + rk_ctable[consonant - 'a'];
	off = small? -1: rk_offset[consonant - 'a'];
    } else {
	n = rk_ctable[vowel - 'a'];
	off = small? -1: 0;
    }
    *(*pp)++ = rk_str[n][0];
    *(*pp)++ = rk_str[n][1] + off;
}

/*
 * rk_yield_doubled - $B;R2;$,O"B3$7$?>l9g$K$+$JJ8;z$r@8@.$9$k(B
 */
void
rk_yield_doubled(pp, c)
uchr	**pp;
int	c;
{
    int		n;

    switch (c) {
    case 0:
	return;
    case 'm':
    case 'n':
	n = rk_ctable['x' - 'a'];
	*(*pp)++ = rk_str[n][0];
	*(*pp)++ = rk_str[n][1];
	break;
#if 0
    case 'h':
	*(*pp) = (*pp)[-2];
	(*pp)++;
	*(*pp) = (*pp)[-2];
	(*pp)++;
	break;
#endif
    default:
	n = rk_ctable['t' - 'a'] + rk_ctable['u' - 'a'];
	*(*pp)++ = rk_str[n][0];
	*(*pp)++ = rk_str[n][1] - 1;
	break;
    }
}

/* ---------- $B%$%s%G%C%/%9%U%!%$%kA`:n(B ---------- */

/*
 * $B8!:w%-!<$N:GBgD9(B
 */
#define	MAXKEYLEN	20

/*
 * $BA0J}0lCW8!:w>r7o(B
 */
#define	RETR_FIRST	0	/* $BA0J}0lCW=i2s(B		*/
#define	RETR_NEXT	1	/* $BA0J}0lCW7QB3(B		*/

/*
 * $B%$%s%G%C%/%9%U%!%$%k%X%C%@!<(B
 */
typedef	struct {
    dword	hdrlen;		/* $B%X%C%@!<$N%5%$%:(B		*/
    dword	unknown1;	/* ($B>o$K(B1?)			*/
    dword	lsttbladdr;	/* LST$BMWAGHV9fI=%"%I%l%9(B	*/
    dword	unknown2;	/* ($B>o$K(B0?)			*/
    dword	unknown3;	/* ($B>o$K(B0?)			*/
    dword	unknown4;	/* ($B>o$K(B0?)			*/
    dword	pagenum;	/* $B%$%s%G%C%/%9%Z!<%8Am?t(B	*/
    dword	pagelen;	/* $B%$%s%G%C%/%9%Z!<%8%5%$%:(B	*/
    dword	entnum;		/* $B%Z!<%8Fb$N9`L\?t(B		*/
    dword	entlen;		/* $B9`L\$N%5%$%:(B			*/
    dword	keylen;		/* $B9`L\%-!<$N%5%$%:(B		*/
    dword	maxlevel;	/* $B%$%s%G%C%/%9$NCJ?t(B		*/
    dword	lpagenum[6];	/* $B3F%l%Y%k$N%Z!<%8?t(B		*/
} IDXHDR;

/*
 * $B%$%s%G%C%/%9%U%!%$%k9`L\(B
 *
 * typedef struct {
 *  uchr	key[keylen];	** $B8!:w%-!<(B			**
 *  dword	lsttbloff;	** LST$BMWAGHV9fI=%*%U%;%C%H(B	**
 *  dword	cand;		** $B8uJd?t(B			**
 * } IDXENT;
 */

char	*idxfile;	/* $B%$%s%G%C%/%9%U%!%$%kL>(B		*/
int	idxfd = -1;	/* $B%$%s%G%C%/%9%U%!%$%k5-=R;R(B		*/
IDXHDR	idxhdr;		/* $B%$%s%G%C%/%9%U%!%$%k%X%C%@!<(B		*/
uchr	*idxpage;	/* $B%$%s%G%C%/%9%Z!<%8(B			*/

/*
 * idx_open - $B%$%s%G%C%/%9%U%!%$%k$r%*!<%W%s$9$k(B
 */
int
idx_open(file)
char	*file;
{
    int		i;
    dword	*p;

    if (idxfd >= 0)
	return ERR;
    if (file == NULL) {
	sprintf(tmp, "%s: $B%$%s%G%C%/%9%U%!%$%k$,$"$j$^$;$s(B\n", progname);
	jc_outstr(tmp);
	return ERR;
    }
    if ((idxfd = open(file, O_RDONLY|O_BINARY)) < 0) {
	sprintf(tmp, "%s: $B%$%s%G%C%/%9%U%!%$%k(B %s $B$,%*!<%W%s$G$-$^$;$s(B\n",
	    progname, file);
	jc_outstr(tmp);
	return ERR;
    }
    if (read(idxfd, (char *)&idxhdr, sizeof(idxhdr)) < sizeof(idxhdr)) {
	sprintf(tmp, "%s: $B%$%s%G%C%/%9%U%!%$%k%X%C%@!<$,FI$a$^$;$s(B\n",
	    progname);
	jc_outstr(tmp);
	return ERR;
    }
    p = (dword *)&idxhdr;
    for (i = 0; i < sizeof(idxhdr) / sizeof(dword); i++)
	p[i] = dval(p[i]);
    idxfile = strdup(file);
    idxpage = malloc((size_t)(idxhdr.pagelen));
    if (idxpage == NULL) {
	sprintf(tmp, "%s: $B%a%b%j!<$,B-$j$^$;$s(B\n", progname);
	jc_outstr(tmp);
	idx_close();
	return ERR;
    }
    return OK;
}

/*
 * idx_close - $B%$%s%G%C%/%9%U%!%$%k$r%/%m!<%:$9$k(B
 */
int
idx_close()
{
    if (idxfd < 0)
	return ERR;
    if (close(idxfd) < 0)
	return ERR;
    free(idxfile);
    idxfd = -1;
    idxfile = NULL;
    if (idxpage != NULL)
	free(idxpage);
    idxpage = NULL;
    return OK;
}

/*
 * idx_hdrinfo - $B%$%s%G%C%/%9%U%!%$%k%X%C%@!<$r%@%s%W$9$k(B
 */
int
idx_hdrinfo()
{
    int		i;
    IDXHDR	*p;

    if (idxfd < 0)
	return ERR;
    p = &idxhdr;
    jc_outstr("$B!T%$%s%G%C%/%9%X%C%@!<>pJs!U(B\n");
    sprintf(tmp, "   IDX$B%U%!%$%kL>(B: %s\n", idxfile);
    jc_outstr(tmp);
    sprintf(tmp, "  $B%X%C%@!<%5%$%:(B: %lu\n", p->hdrlen);
    jc_outstr(tmp);
    sprintf(tmp, "   LST$BMWAGHV9fI=(B: 0x%lx\n", p->lsttbladdr);
    jc_outstr(tmp);
    sprintf(tmp, "   IDX$B%Z!<%8Am?t(B: %lu\n", p->pagenum);
    jc_outstr(tmp);
    sprintf(tmp, " IDX$B%Z!<%8%5%$%:(B: %lu\n", p->pagelen);
    jc_outstr(tmp);
    sprintf(tmp, "  $B%Z!<%8Fb9`L\?t(B: %lu\n", p->entnum);
    jc_outstr(tmp);
    sprintf(tmp, "      $B9`L\%5%$%:(B: %lu\n", p->entlen);
    jc_outstr(tmp);
    sprintf(tmp, "  $B9`L\%-!<%5%$%:(B: %lu\n", p->keylen);
    jc_outstr(tmp);
    sprintf(tmp, "      $B%Z!<%8CJ?t(B: %lu\n", p->maxlevel);
    jc_outstr(tmp);
    for (i = 0; i < p->maxlevel; i++) {
	sprintf(tmp, " $B%l%Y%k(B%d$B%Z!<%8?t(B: %lu\n", i, p->lpagenum[i]);
	jc_outstr(tmp);
    }
    printf("\n");
    return OK;
}

/*
 * idx_retrieve - $B%$%s%G%C%/%9%U%!%$%k$rFI$_$G40A40lCW8!:w$9$k(B
 *		  $B7k2L$O(BLST$B%U%!%$%kCf$NMWAG0LCV$HF12;8l8uJd?t(B
 */
int
idx_retrieve(key, lstidxpp, candp)
uchr	*key;
dword	**lstidxpp, *candp;
{
    int		i, n, level, off;
    dword	lstoff, *lstidxp, cand;
    uchr	*s;

    if (idxfd < 0)
	return ERR;
    off = 0;
    for (level = 0; level < idxhdr.maxlevel; level++) {
	if (idx_getpage(level, off) != OK)
	    return ERR;
	s = idxpage;
	for (i = 0; i < idxhdr.entnum; i++) {
	    if ((n = compare(s, key, (size_t)(idxhdr.keylen))) >= 0)
		break;
	    s += idxhdr.entlen;
	}
	if (i >= idxhdr.entnum || *s == 0xff)
	    return ERR;
	if (n == 0) {
	    cand = sdval(s + idxhdr.keylen + sizeof(dword));
	    lstidxp = (dword *)malloc(sizeof(dword) * (size_t)cand);
	    if (lstidxp == NULL)
		return ERR;
	    lstoff = sdval(s + idxhdr.keylen);
	    if (idx_getlstidx(lstoff, cand, lstidxp) != OK) {
		free((char *)lstidxp);
		return ERR;
	    }
	    *lstidxpp = lstidxp;
	    *candp = cand;
	    return OK;
	}
	off = idxhdr.entnum * off + i;
    }
    return ERR;
}

/*
 * idx_retrieve2 - $B%$%s%G%C%/%9%U%!%$%k$rFI$_$GA0J}0lCW8!:w$9$k(B
 *		   $B7k2L$O(BLST$B%U%!%$%kCf$NMWAG0LCV$HF12;8l8uJd?t(B
 */
int
idx_retrieve2(key, flag, newkeyp, lstidxpp, candp)
uchr	*key;
int	flag;
uchr	**newkeyp;
dword	**lstidxpp, *candp;
{
    int		i, n;
    dword	lstoff, *lstidxp, cand;
    uchr	*s;
    static int	level, off, entno, len;
    static uchr	newkey[MAXKEYLEN + 1];

    if (idxfd < 0)
	return ERR;
    if (flag == RETR_FIRST) {
	len = strlen(key);
	off = 0;
	for (level = 0; level < idxhdr.maxlevel; level++) {
	    if (idx_getpage(level, off) != OK)
		return ERR;
	    s = idxpage;
	    for (i = 0; i < idxhdr.entnum; i++) {
		if ((n = compare(s, key, (size_t)len)) >= 0)
		    break;
		s += idxhdr.entlen;
	    }
	    if (i >= idxhdr.entnum || *s == 0xff)
		return ERR;
	    if (n == 0 && level == idxhdr.maxlevel - 1) {
		cand = sdval(s + idxhdr.keylen + sizeof(dword));
		lstidxp = (dword *)malloc(sizeof(dword) * (size_t)cand);
		if (lstidxp == NULL)
		    return ERR;
		lstoff = sdval(s + idxhdr.keylen);
		if (idx_getlstidx(lstoff, cand, lstidxp) != OK) {
		    free((char *)lstidxp);
		    return ERR;
		}
		memcpy(newkey, s, (size_t)(idxhdr.keylen));
		newkey[(int)(idxhdr.keylen)] = '\0';
		*newkeyp = newkey;
		*lstidxpp = lstidxp;
		*candp = cand;
		entno = i;
		return OK;
	    }
	    off = idxhdr.entnum * off + i;
	}
	return ERR;
    }
    /* flag == RETR_NEXT */
    if (++entno >= idxhdr.entnum) {
	if (idx_getpage(level, ++off) != OK)
	    return ERR;
	entno = 0;
    }
    s = idxpage + idxhdr.entlen * entno;
    if (compare(s, key, (size_t)len) > 0)
	return ERR;
    cand = sdval(s + idxhdr.keylen + sizeof(dword));
    lstidxp = (dword *)malloc(sizeof(dword) * (size_t)cand);
    if (lstidxp == NULL)
	return ERR;
    lstoff = sdval(s + idxhdr.keylen);
    if (idx_getlstidx(lstoff, cand, lstidxp) != OK) {
	free((char *)lstidxp);
	return ERR;
    }
    memcpy(newkey, s, (size_t)(idxhdr.keylen));
    newkey[(int)(idxhdr.keylen)] = '\0';
    *newkeyp = newkey;
    *lstidxpp = lstidxp;
    *candp = cand;
    return OK;
}

/*
 * idx_getpage - $B%$%s%G%C%/%9%U%!%$%k$+$i;XDj%l%Y%k!";XDj%*%U%;%C%H$N(B
 *		 $B%Z!<%8$rFI$_=P$9(B
 */
int
idx_getpage(level, off)
int	level, off;
{
    int		i;
    long	pos;
    size_t	len;

    pos = (long)(idxhdr.hdrlen);
    len = (size_t)(idxhdr.pagelen);
    for (i = 0; i < level; i++)
	pos += (long)len * idxhdr.lpagenum[i];
    pos += (long)len * off;
    if (lseek(idxfd, pos, 0) < 0)
	return ERR;
    if (read(idxfd, (char *)idxpage, len) < len)
	return ERR;
    return OK;
}

/*
 * idx_getlstidx - $B%$%s%G%C%/%9%U%!%$%k$NKvHx$K$"$k(BLST$B%U%!%$%k(B
 *		   $BMWAGHV9fI=$+$iMWAGHV9f$r<h$j=P$7$FJV$9(B
 */
int
idx_getlstidx(lstoff, cand, lstidxp)
dword	lstoff, cand, *lstidxp;
{
    int		i;
    size_t	len;

    if (lseek(idxfd, (long)(idxhdr.lsttbladdr) + lstoff, 0) < 0)
	return ERR;
    len = sizeof(dword) * (size_t)cand;
    if (read(idxfd, (char *)lstidxp, len) < len)
	return ERR;
    for (i = 0; i < (int)cand; i++)
	lstidxp[i] = dval(lstidxp[i]);
    return OK;
}

/*
 * idx_dumpkey - $B%$%s%G%C%/%9%U%!%$%kCf$K$"$k$9$Y$F$N%-!<$rI=<($9$k(B
 */
int
idx_dumpkey(verbose)
int	verbose;
{
    int		i, j, pagenum;
    long	pos, cnt;
    size_t	len;
    uchr	*p;

    if (idxfd < 0)
	return ERR;
    pos = (long)(idxhdr.hdrlen);
    len = (size_t)(idxhdr.pagelen);
    for (i = 0; i < idxhdr.maxlevel - 1; i++)
	pos += (long)len * idxhdr.lpagenum[i];
    if (lseek(idxfd, pos, 0) < 0)
	return ERR;
    pagenum = (int)(idxhdr.lpagenum[idxhdr.maxlevel - 1]);
    cnt = 0L;
    for (i = 0; i < pagenum; i++) {
	if (read(idxfd, (char *)idxpage, len) < len)
	    return ERR;
	p = idxpage;
	for (j = 0; j < idxhdr.entnum; j++) {
	    if (*p == 0xff)
		break;
	    sprintf(tmp, "%-.*s (%ld)\n", (int)(idxhdr.keylen), p,
		sdval(p + idxhdr.keylen + sizeof(dword)));
	    jc_outstr(tmp);
	    p += idxhdr.entlen;
	    cnt++;
	}
    }
    printf("\n");
    if (verbose) {
	sprintf(tmp, "%ld$B7o$N7k2L$,I=<($5$l$^$7$?(B\n\n", cnt);
	jc_outstr(tmp);
    }
    return OK;
}

/* ---------- $B4A;z8!:w(BDN$B%$%s%G%C%/%9%U%!%$%kA`:n(B ---------- */

/*
 * $B4A;z8!:w(BDN$B%$%s%G%C%/%9%U%!%$%k%X%C%@!<(B
 */
typedef	struct {
    dword	hdrlen;		/* $B%X%C%@!<$N%5%$%:(B		*/
    dword	unknown1;	/* ($B>o$K(B1?)			*/
    dword	lsttbladdr;	/* LST$BMWAGHV9fI=%"%I%l%9(B	*/
    dword	unknown2;	/* ($B>o$K(B0?)			*/
    dword	unknown3;	/* ($B>o$K(B0?)			*/
    dword	unknown4;	/* ($B>o$K(B0?)			*/
    dword	lsttblnum;	/* LST$BMWAGHV9fI=9`L\?t(B?		*/
    dword	unknown5;	/* ($B>o$K(B0?)			*/
    dword	unknown6;	/* ($B>o$K(B0?)			*/
    dword	unknown7;	/* ($B>o$K(B0?)			*/
    dword	entnum;		/* $B%$%s%G%C%/%99`L\?t(B		*/
    dword	entlen;		/* $B%$%s%G%C%/%99`L\$N%5%$%:(B	*/
    dword	unknown8;	/* ($B>o$K(B1?)			*/
    dword	unknown9;	/* ($B%$%s%G%C%/%99`L\?t$HF1$8(B?)	*/
    dword	unknown10;	/* ($B>o$K(B1?)			*/
    dword	unknown11;	/* ($B>o$K(B0?)			*/
} DNHDR;

/*
 * $B4A;z8!:w(BDN$B%$%s%G%C%/%99`L\(B
 */
typedef	struct {
    dword	lsttbloff;	/* LST$BMWAGHV9fI=%*%U%;%C%H(B	*/
    dword	lsttblcand;	/* LST$BMWAGHV9fI=8uJd?t(B		*/
    dword	unknown;	/* $B8uJd?tN_7W(B?			*/
} DNENT;

char	*dnfile;	/* DN$B%$%s%G%C%/%9%U%!%$%kL>(B		*/
int	dnfd = -1;	/* DN$B%$%s%G%C%/%9%U%!%$%k5-=R;R(B		*/
DNHDR	dnhdr;		/* DN$B%$%s%G%C%/%9%U%!%$%k%X%C%@!<(B		*/

/*
 * dn_open - $B4A;z8!:w(BDN$B%$%s%G%C%/%9%U%!%$%k$r%*!<%W%s$9$k(B
 */
int
dn_open(file)
char	*file;
{
    int		i;
    dword	*p;

    if (dnfd >= 0)
	return ERR;
    if (file == NULL) {
	sprintf(tmp, "%s: DN$B%$%s%G%C%/%9%U%!%$%k$,$"$j$^$;$s(B\n", progname);
	jc_outstr(tmp);
	return ERR;
    }
    if ((dnfd = open(file, O_RDONLY|O_BINARY)) < 0) {
	sprintf(tmp, "%s: DN$B%$%s%G%C%/%9%U%!%$%k(B %s $B$,%*!<%W%s$G$-$^$;$s(B\n",
	    progname, file);
	jc_outstr(tmp);
	return ERR;
    }
    if (read(dnfd, (char *)&dnhdr, sizeof(dnhdr)) < sizeof(dnhdr)) {
	sprintf(tmp, "%s: DN$B%$%s%G%C%/%9%U%!%$%k%X%C%@!<$,FI$a$^$;$s(B\n",
	    progname);
	jc_outstr(tmp);
	return ERR;
    }
    p = (dword *)&dnhdr;
    for (i = 0; i < sizeof(dnhdr) / sizeof(dword); i++)
	p[i] = dval(p[i]);
    dnfile = strdup(file);
    return OK;
}

/*
 * dn_close - $B4A;z8!:w(BDN$B%$%s%G%C%/%9%U%!%$%k$r%/%m!<%:$9$k(B
 */
int
dn_close()
{
    if (dnfd < 0)
	return ERR;
    if (close(dnfd) < 0)
	return ERR;
    free(dnfile);
    dnfd = -1;
    dnfile = NULL;
    return OK;
}

/*
 * dn_hdrinfo - $B4A;z8!:w(BDN$B%$%s%G%C%/%9%U%!%$%k%X%C%@!<$r%@%s%W$9$k(B
 */
int
dn_hdrinfo()
{
    DNHDR	*p;

    if (dnfd < 0)
	return ERR;
    p = &dnhdr;
    jc_outstr("$B!T4A;z8!:w(BDN$B%$%s%G%C%/%9%X%C%@!<>pJs!U(B\n");
    sprintf(tmp, "    DN$B%U%!%$%kL>(B: %s\n", dnfile);
    jc_outstr(tmp);
    sprintf(tmp, "  $B%X%C%@!<%5%$%:(B: %lu\n", p->hdrlen);
    jc_outstr(tmp);
    sprintf(tmp, "   LST$BMWAGHV9fI=(B: 0x%lx\n", p->lsttbladdr);
    jc_outstr(tmp);
    sprintf(tmp, "          $B9`L\?t(B: %lu\n", p->entnum);
    jc_outstr(tmp);
    sprintf(tmp, "      $B9`L\%5%$%:(B: %lu\n", p->entlen);
    jc_outstr(tmp);
    printf("\n");
    return OK;
}

/*
 * dn_retrieve - $B4A;z8!:w(BDN$B%$%s%G%C%/%9%U%!%$%k$+$iMWAGHV9f$G8!:w$9$k(B
 *		 $B7k2L$O(BLST$B%U%!%$%kCf$NMWAG0LCV$HF10lMWAG8uJd?t(B
 */
int
dn_retrieve(num, lstidxpp, candp)
dword	num, **lstidxpp, *candp;
{
    long	pos;
    dword	*lstidxp, cand;
    DNENT	dnent;

    if (dnfd < 0)
	return ERR;
    num--;
    if (num >= dnhdr.entnum)
	return ERR;
    pos = sizeof(DNHDR) + (long)(dnhdr.entlen) * (size_t)num;
    if (lseek(dnfd, pos, 0) < 0)
	return ERR;
    if (read(dnfd, (char *)&dnent, sizeof(DNENT)) < sizeof(DNENT))
	return ERR;
    cand = dval(dnent.lsttblcand);
    lstidxp = (dword *)malloc(sizeof(dword) * (size_t)cand);
    if (lstidxp == NULL)
	return ERR;
    if (dn_getlstidx(dval(dnent.lsttbloff), cand, lstidxp) != OK) {
	free((char *)lstidxp);
	return ERR;
    }
    *lstidxpp = lstidxp;
    *candp = cand;
    return OK;
}

/*
 * dn_getlstidx - $B4A;z8!:w(BDN$B%$%s%G%C%/%9%U%!%$%k$NKvHx$K$"$k(BLST$B%U%!%$%k(B
 *		  $BMWAGHV9fI=$+$iMWAGHV9f$r<h$j=P$7$FJV$9(B
 */
int
dn_getlstidx(lstoff, cand, lstidxp)
dword	lstoff, cand, *lstidxp;
{
    int		i;
    size_t	len;

    if (lseek(dnfd, (long)(dnhdr.lsttbladdr) + lstoff, 0) < 0)
	return ERR;
    len = sizeof(dword) * (size_t)cand;
    if (read(dnfd, (char *)lstidxp, len) < len)
	return ERR;
    for (i = 0; i < (int)cand; i++)
	lstidxp[i] = dval(lstidxp[i]);
    return OK;
}

/* ---------- $B4A;z8!:w(BSLS$B%U%!%$%kA`:n(B ---------- */

/*
 * $B4A;z8!:w(BSLS$B%U%!%$%k%X%C%@!<(B
 */
typedef	struct {
    dword	hdrlen;		/* $B%X%C%@!<$N%5%$%:(B		*/
    dword	unknown1;	/* ($B>o$K(B1?)			*/
    dword	lsttbladdr;	/* LST$BMWAGHV9fI=%"%I%l%9(B	*/
    dword	entnum;		/* $B%$%s%G%C%/%99`L\?t(B		*/
    dword	entlen;		/* $B%$%s%G%C%/%99`L\$N%5%$%:(B	*/
    dword	labellen;	/* $B%$%s%G%C%/%9%i%Y%k$N%5%$%:(B	*/
    dword	auxlen;		/* $BJd=u%G!<%?$N%5%$%:(B		*/
    dword	unknown2;	/* ($B>o$K(B0?)			*/
} SLSHDR;

/*
 * SLS$B%U%!%$%k9`L\(B
 *
 * typedef struct {
 *  uchr	label[labellen]; ** $B%$%s%G%C%/%9%i%Y%k(B		**
 *  dword	unknown1;	** ($B>o$K(B0xffffffff?)		**
 *  dword	unknown2;	** ($B>o$K(B0?)			**
 *  dword	lsttbloff;	** LST$BMWAGHV9fI=%*%U%;%C%H(B	**
 *  dword	cand;		** $B8uJd?t(B			**
 * } SLSENT;
 */

char	*slsfile;	/* SLS$B%U%!%$%kL>(B			*/
int	slsfd = -1;	/* SLS$B%U%!%$%k5-=R;R(B			*/
SLSHDR	slshdr;		/* SLS$B%U%!%$%k%X%C%@!<(B			*/
uchr	*slsent;	/* SLS$B9`L\(B				*/

/*
 * sls_open - $B4A;z8!:w(BSLS$B%U%!%$%k$r%*!<%W%s$9$k(B
 */
int
sls_open(file)
char	*file;
{
    int		i;
    dword	*p;

    if (slsfd >= 0)
	return ERR;
    if (file == NULL) {
	sprintf(tmp, "%s: SLS$B%U%!%$%k$,$"$j$^$;$s(B\n", progname);
	jc_outstr(tmp);
	return ERR;
    }
    if ((slsfd = open(file, O_RDONLY|O_BINARY)) < 0) {
	sprintf(tmp, "%s: SLS$B%U%!%$%k(B %s $B$,%*!<%W%s$G$-$^$;$s(B\n",
	    progname, file);
	jc_outstr(tmp);
	return ERR;
    }
    if (read(slsfd, (char *)&slshdr, sizeof(slshdr)) < sizeof(slshdr)) {
	sprintf(tmp, "%s: SLS$B%U%!%$%k%X%C%@!<$,FI$a$^$;$s(B\n",
	    progname);
	jc_outstr(tmp);
	return ERR;
    }
    p = (dword *)&slshdr;
    for (i = 0; i < sizeof(slshdr) / sizeof(dword); i++)
	p[i] = dval(p[i]);
    slsfile = strdup(file);
    slsent = malloc((size_t)(slshdr.entlen));
    if (slsent == NULL) {
	sprintf(tmp, "%s: $B%a%b%j!<$,B-$j$^$;$s(B\n", progname);
	jc_outstr(tmp);
	sls_close();
	return ERR;
    }
    return OK;
}

/*
 * sls_close - $B4A;z8!:w(BSLS$B%U%!%$%k$r%/%m!<%:$9$k(B
 */
int
sls_close()
{
    if (slsfd < 0)
	return ERR;
    if (close(slsfd) < 0)
	return ERR;
    free(slsfile);
    slsfd = -1;
    slsfile = NULL;
    if (slsent != NULL)
	free(slsent);
    slsent = NULL;
    return OK;
}

/*
 * sls_hdrinfo - $B4A;z8!:w(BSLS$B%U%!%$%k%X%C%@!<$r%@%s%W$9$k(B
 */
int
sls_hdrinfo()
{
    SLSHDR	*p;

    if (slsfd < 0)
	return ERR;
    p = &slshdr;
    jc_outstr("$B!T4A;z8!:w(BSLS$B%X%C%@!<>pJs!U(B\n");
    sprintf(tmp, "   SLS$B%U%!%$%kL>(B: %s\n", slsfile);
    jc_outstr(tmp);
    sprintf(tmp, "  $B%X%C%@!<%5%$%:(B: %lu\n", p->hdrlen);
    jc_outstr(tmp);
    sprintf(tmp, "   LST$BMWAGHV9fI=(B: 0x%lx\n", p->lsttbladdr);
    jc_outstr(tmp);
    sprintf(tmp, "          $B9`L\?t(B: %lu\n", p->entnum);
    jc_outstr(tmp);
    sprintf(tmp, "      $B9`L\%5%$%:(B: %lu\n", p->entlen);
    jc_outstr(tmp);
    sprintf(tmp, "    $B%i%Y%k%5%$%:(B: %lu\n", p->labellen);
    jc_outstr(tmp);
    sprintf(tmp, "$BJd=u%G!<%?%5%$%:(B: %lu\n", p->auxlen);
    jc_outstr(tmp);
    printf("\n");
    return OK;
}

/*
 * sls_retrieve - $B4A;z8!:w(BSLS$B%U%!%$%k$+$iMWAGHV9f$G8!:w$9$k(B
 *		  $B7k2L$O(BLST$B%U%!%$%kCf$NMWAG0LCV$HF10lMWAG8uJd?t(B
 */
int
sls_retrieve(num, lstidxpp, candp)
dword	num, **lstidxpp, *candp;
{
    long	pos;
    size_t	len;
    dword	*lstidxp, cand;
    uchr	*s;

    if (slsfd < 0)
	return ERR;
    num--;
    if (num >= slshdr.entnum)
	return ERR;
    len = (size_t)(slshdr.entlen);
    pos = sizeof(SLSHDR) + (long)len * (long)num;
    if (lseek(slsfd, pos, 0) < 0)
	return ERR;
    if (read(slsfd, (char *)slsent, len) < len)
	return ERR;
    s = slsent + slshdr.labellen + slshdr.auxlen +
	sizeof(dword) + sizeof(dword);
    cand = sdval(s + sizeof(dword));
    lstidxp = (dword *)malloc(sizeof(dword) * (size_t)cand);
    if (lstidxp == NULL)
	return ERR;
    if (sls_getlstidx(sdval(s), cand, lstidxp) != OK) {
	free((char *)lstidxp);
	return ERR;
    }
    *lstidxpp = lstidxp;
    *candp = cand;
    return OK;
}

/*
 * sls_getlstidx - $B4A;z8!:w(BSLS$B%U%!%$%k$NKvHx$K$"$k(BLST$B%U%!%$%k(B
 *		   $BMWAGHV9fI=$+$iMWAGHV9f$r<h$j=P$7$FJV$9(B
 */
int
sls_getlstidx(lstoff, cand, lstidxp)
dword	lstoff, cand, *lstidxp;
{
    int		i;
    size_t	len;

    if (lseek(slsfd, (long)(slshdr.lsttbladdr) + lstoff, 0) < 0)
	return ERR;
    len = sizeof(dword) * (size_t)cand;
    if (read(slsfd, (char *)lstidxp, len) < 0)
	return ERR;
    for (i = 0; i < (int)cand; i++)
	lstidxp[i] = dval(lstidxp[i]);
    return OK;
}

/*
 * sls_readentry - $B:G=i$N(B($B<!$N(B)$B%G!<%?9`L\$r<h$j=P$7$FJV$9(B
 */
int
sls_readentry(flag, slsentpp)
int	flag;
uchr	**slsentpp;
{
    size_t	len;
    uchr	*slsentp;

    if (slsfd < 0)
	return ERR;
    if (flag == READ_FIRST) {
	if (lseek(slsfd, (long)sizeof(SLSHDR), 0) < 0)
	    return ERR;
    }
    if (lseek(slsfd, 0L, 1) >= (long)(slshdr.lsttbladdr))
	return ERR;
    len = (size_t)(slshdr.entlen);
    slsentp = malloc(len);
    if (slsentp == NULL) {
	sprintf(tmp, "%s: $B%a%b%j!<$,B-$j$^$;$s(B\n", progname);
	jc_outstr(tmp);
	sls_close();
	return ERR;
    }
    if (read(slsfd, (char *)slsentp, len) < len)
	return ERR;
    *slsentpp = slsentp;
    return OK;
}

/* ---------- LST$B%U%!%$%kA`:n(B ---------- */

/*
 * $B8+=P$7$N:GBgD9(B
 */
#define	MAXLABELLEN	42

/*
 * LST$B%U%!%$%k%X%C%@!<(B
 */
typedef	struct {
    uchr	unknown1[42];	/* ($B>o$K(B0?)			*/
    uchr	entnum[4];	/* LST$B%G!<%?7o?t(B		*/
    uchr	unknown2[8];	/* ($B>o$K(B0?)			*/
} LSTHDR;

/*
 * LST$B%U%!%$%k$N%G!<%?9`L\(B
 */
typedef	struct {
    uchr	label[MAXLABELLEN]; /* $B8+=P$7(B($BI,$:(B0x00$B$G=*$o$k(B)	*/
    uchr	datpnum[4];	/* DAT$B%Z!<%8HV9f(B($B4A;z8!:wMQ(B)	*/
    uchr	datpage[4];	/* DAT$B%Z!<%8HV9f(B(+$B%*%U%;%C%H(B)	*/
    uchr	datoff[4];	/* DAT$B%Z!<%8Fb%*%U%;%C%H(B	*/
} LSTENT;

char	*lstfile;	/* LST$B%U%!%$%kL>(B			*/
int	lstfd = -1;	/* LST$B%U%!%$%k5-=R;R(B			*/
LSTHDR	lsthdr;		/* LST$B%U%!%$%k%X%C%@!<(B			*/
dword	lstentnum;	/* LST$B%G!<%?7o?t(B			*/

/*
 * lst_open - LST$B%U%!%$%k$r%*!<%W%s$9$k(B
 */
int
lst_open(file)
char	*file;
{
    int		i;
    dword	*p;

    if (lstfd >= 0)
	return ERR;
    if (file == NULL) {
	sprintf(tmp, "%s: LST$B%U%!%$%k$,$"$j$^$;$s(B\n", progname);
	jc_outstr(tmp);
	return ERR;
    }
    if ((lstfd = open(file, O_RDONLY|O_BINARY)) < 0) {
	sprintf(tmp, "%s: LST$B%U%!%$%k(B %s $B$,%*!<%W%s$G$-$^$;$s(B\n",
	    progname, file);
	jc_outstr(tmp);
	return ERR;
    }
    if (read(lstfd, (char *)&lsthdr, sizeof(lsthdr)) < sizeof(lsthdr)) {
	sprintf(tmp, "%s: LST$B%U%!%$%k%X%C%@!<$,FI$a$^$;$s(B\n", progname);
	jc_outstr(tmp);
	return ERR;
    }
    lstentnum = sdval(lsthdr.entnum);
    lstfile = strdup(file);
    return OK;
}

/*
 * lst_close - LST$B%U%!%$%k$r%/%m!<%:$9$k(B
 */
int
lst_close()
{
    if (lstfd < 0)
	return ERR;
    if (close(lstfd) < 0)
	return ERR;
    free(lstfile);
    lstfd = -1;
    lstfile = NULL;
    return OK;
}

/*
 * lst_hdrinfo - LST$B%U%!%$%k%X%C%@!<$r%@%s%W$9$k(B
 */
int
lst_hdrinfo()
{
    if (lstfd < 0)
	return ERR;
    jc_outstr("$B!T(BLST$B%X%C%@!<>pJs!U(B\n");
    sprintf(tmp, "   LST$B%U%!%$%kL>(B: %s\n", lstfile);
    jc_outstr(tmp);
    sprintf(tmp, "   LST$B%G!<%?7o?t(B: %lu\n", lstentnum);
    jc_outstr(tmp);
    printf("\n");
    return OK;
}

/*
 * lst_getentry - $B;XDjMWAG0LCV$+$i;XDj8D?t$N4pK\MWAG$r4^$`(B
 *		  $B%G!<%?9`L\$r<h$j=P$7$FJV$9(B
 */
int
lst_getentry(entno, lstentp)
dword	entno;
LSTENT	*lstentp;
{
    long	pos;
    LSTENT	lebuf;

    if (lstfd < 0)
	return ERR;
    if (entno == 0 || entno > lstentnum)
	return ERR;
    pos = (long)sizeof(LSTENT) * (entno - 1) + sizeof(LSTHDR);
    if (lseek(lstfd, pos, 0) < 0)
	return ERR;
    if (read(lstfd, (char *)&lebuf, sizeof(LSTENT)) < sizeof(LSTENT))
	return ERR;
    *lstentp = lebuf;
    return OK;
}

/*
 * lst_readentry - $B:G=i$N(B($B<!$N(B)$B%G!<%?9`L\$r<h$j=P$7$FJV$9(B
 */
int
lst_readentry(flag, lstentp)
int	flag;
LSTENT	*lstentp;
{
    LSTENT	lebuf;

    if (lstfd < 0)
	return ERR;
    if (flag == READ_FIRST) {
	if (lseek(lstfd, (long)sizeof(LSTHDR), 0) < 0)
	    return ERR;
    }
    if (read(lstfd, (char *)&lebuf, sizeof(LSTENT)) < sizeof(LSTENT))
	return ERR;
    *lstentp = lebuf;
    return OK;
}

/* ---------- DAT$B%U%!%$%kA`:n(B ---------- */

#define	DATPAGEMAX	32000	/* DAT$B%Z!<%8:GBgD9(B		*/

/*
 * DAT$B%U%!%$%k%X%C%@!<(B
 */
typedef	struct {
    dword	pagenum;	/* DAT$B%Z!<%8Am?t(B		*/
} DATHDR;

/*
 * DAT$B%U%!%$%k@hF,$K$"$k%Z!<%8I=(B
 */
typedef	struct {
    dword	pageaddr;	/* DAT$B%Z!<%83+;O%"%I%l%9(B	*/
    dword	pagelen;	/* DAT$B%Z!<%8%5%$%:(B		*/
} DATPAGETBL;

char	*datfile;	/* DAT$B%U%!%$%kL>(B			*/
int	datfd = -1;	/* DAT$B%U%!%$%k5-=R;R(B			*/
DATHDR	dathdr;		/* DAT$B%U%!%$%k%X%C%@!<(B			*/
uchr	*datpage;	/* DAT$B%Z!<%8(B				*/
dword	dpagelen;	/* DAT$B%Z!<%8$N%5%$%:(B			*/

/*
 * dat_open - DAT$B%U%!%$%k$r%*!<%W%s$9$k(B
 */
int
dat_open(file)
char	*file;
{
    int		i;
    dword	*p;

    if (datfd >= 0)
	return ERR;
    if (file == NULL) {
	sprintf(tmp, "%s: DAT$B%U%!%$%k$,$"$j$^$;$s(B\n", progname);
	jc_outstr(tmp);
	return ERR;
    }
    if ((datfd = open(file, O_RDONLY|O_BINARY)) < 0) {
	sprintf(tmp, "%s: DAT$B%U%!%$%k(B %s $B$,%*!<%W%s$G$-$^$;$s(B\n",
	    progname, file);
	jc_outstr(tmp);
	return ERR;
    }
    if (read(datfd, (char *)&dathdr, sizeof(dathdr)) < sizeof(dathdr)) {
	sprintf(tmp, "%s: DAT$B%U%!%$%k%X%C%@!<$,FI$a$^$;$s(B\n", progname);
	jc_outstr(tmp);
	return ERR;
    }
    p = (dword *)&dathdr;
    for (i = 0; i < sizeof(dathdr) / sizeof(dword); i++)
	p[i] = dval(p[i]);
    datfile = strdup(file);
    datpage = malloc((size_t)DATPAGEMAX);
    if (datpage == NULL) {
	sprintf(tmp, "%s: $B%a%b%j!<$,B-$j$^$;$s(B\n", progname);
	jc_outstr(tmp);
	dat_close();
	return ERR;
    }
    return OK;
}

/*
 * dat_close - DAT$B%U%!%$%k$r%/%m!<%:$9$k(B
 */
int
dat_close()
{
    if (datfd < 0)
	return ERR;
    if (close(datfd) < 0)
	return ERR;
    free(datfile);
    datfd = -1;
    datfile = NULL;
    if (datpage != NULL)
	free(datpage);
    datpage = NULL;
    return OK;
}

/*
 * dat_hdrinfo - DAT$B%U%!%$%k%X%C%@!<$r%@%s%W$9$k(B
 */
int
dat_hdrinfo()
{
    if (datfd < 0)
	return ERR;
    jc_outstr("$B!T(BDAT$B%X%C%@!<>pJs!U(B\n");
    sprintf(tmp, "   DAT$B%U%!%$%kL>(B: %s\n", datfile);
    jc_outstr(tmp);
    sprintf(tmp, "   DAT$B%Z!<%8Am?t(B: %lu\n", dathdr.pagenum);
    jc_outstr(tmp);
    printf("\n");
    return OK;
}

/*
 * dat_getentry - $B;XDj%Z!<%8$N;XDj%*%U%;%C%H$+$i;O$^$k9`L\$r<h$j=P$9(B
 *		  $B9`L\$N=*$o$j$OO"B3$9$k(B2$B$D$N2~9T(B(0x0d)$B$GH=Dj$9$k(B
 */
int
dat_getentry(page, off, buf)
dword	page, off;
uchr	*buf;
{
    uchr	*p, *q;

    if (datfd < 0)
	return ERR;
    if (dat_getpage(page) != OK)
	return ERR;
    if (off >= dpagelen)
	return ERR;
    p = datpage + off;
    q = buf;
    while (p < datpage + (int)dpagelen) {
	if (*p == 0x0d) {
	    *q++ = '\n';
	    if (*++p == 0x0d)
		break;
	} else {
	    *q++ = *p++;
	}
    }
    *q = '\0';
    return OK;
}

/*
 * dat_dumppage - $B;XDj$5$l$?%Z!<%8$NFbMF$r%@%s%W$9$k(B
 */
int
dat_dumppage(startpage, endpage)
dword	startpage, endpage;
{
    dword	page;
    uchr	*p;

    if (datfd < 0)
	return ERR;
    for (page = startpage; page <= endpage; page++) {
	if (dat_getpage(page) != OK)
	    return ERR;
	jc_outstr("$B!T(BDAT$B%Z!<%8%@%s%W!U(B\n");
	sprintf(tmp, "DAT$B%Z!<%8HV9f(B: %ld\n", (long)page);
	jc_outstr(tmp);
	sprintf(tmp, "  DAT$B%Z!<%8D9(B: %ld\n", (long)dpagelen);
	jc_outstr(tmp);
	printf("\n");
	for (p = datpage; p < datpage + (int)dpagelen; p++) {
	    if (*p == 0x0d)
		*p = '\n';
	}
	while (p[-1] == '\n' && p[-2] == '\n')
	    p--;
	*p = '\0';
	jc_output(datpage);
	printf("\n");
    }
    return OK;
}

/*
 * dat_getpage - DAT$B%U%!%$%k$+$i;XDj$5$l$?%Z!<%8$r<h$j=P$9(B
 */
int
dat_getpage(page)
{
    int		i;
    long	pos;
    size_t	len;
    dword	*p;
    DATPAGETBL	dpagetbl;
    static dword prevpage = FFFFFFFF;

    if (datfd < 0)
	return ERR;
    if (page == prevpage)
	return OK;
    if (page == 0 || page > dathdr.pagenum)
	return ERR;
    pos = (long)sizeof(DATPAGETBL) * (page - 1) + sizeof(DATHDR);
    if (lseek(datfd, pos, 0) < 0)
	return ERR;
    len = sizeof(DATPAGETBL);
    if (read(datfd, (char *)&dpagetbl, len) < len)
	return ERR;
    p = (dword *)&dpagetbl;
    for (i = 0; i < sizeof(dpagetbl) / sizeof(dword); i++) {
	p[i] = dval(p[i]);
    }
    dpagelen = dpagetbl.pagelen;
    if (dpagelen > (dword)DATPAGEMAX)
	return ERR;
    if (lseek(datfd, (long)(dpagetbl.pageaddr), 0) < 0)
	return ERR;
    if (read(datfd, datpage, (size_t)dpagelen) < dpagelen)
	return ERR;
    prevpage = page;
    return OK;
}

/* ---------- INF$B%U%!%$%kA`:n(B ---------- */

#define	INFPAGEMAX	0xffff	/* INF$B%Z!<%8:GBgD9(B		*/

/*
 * INF$B%U%!%$%k%X%C%@!<(B
 */
typedef	struct {
    dword	pagenum;	/* INF$B%Z!<%8Am?t(B		*/
    dword	unknown;	/* ($B>o$K(B6?)			*/
} INFHDR;

/*
 * INF$B%U%!%$%k@hF,$K$"$k%Z!<%8I=(B
 */
typedef	struct {
    dword	pageaddr;	/* INF$B%Z!<%83+;O%"%I%l%9(B	*/
    dword	pagelen;	/* INF$B%Z!<%8%5%$%:(B		*/
} INFPAGETBL;

/*
 * INF$B%Z!<%8@hF,$K$"$k%X%C%@!<(B
 */
typedef	struct {
    dword	iaddr;		/* $BIUBS>pJsI=%"%I%l%9(B		*/
    dword	unknown1;	/* ($B>o$K(B0?)			*/
    dword	attraddr;	/* $BJ8;zB0@-I=%"%I%l%9(B		*/
    dword	attrlen;	/* $BJ8;zB0@-I=%5%$%:(B		*/
    dword	linkaddr;	/* $B%j%s%/>pJsI=%"%I%l%9(B		*/
    dword	linklen;	/* $B%j%s%/>pJsI=%5%$%:(B		*/
    dword	idxaddr;	/* $B8+=P$7>pJsI=%"%I%l%9(B		*/
    dword	idxlen;		/* $B8+=P$7>pJsI=%5%$%:(B		*/
    dword	daddr;		/* $B%G!<%?I=%"%I%l%9(B		*/
    dword	unknown2;	/* ($B>o$K(B0?)			*/
    dword	labeladdr;	/* $B8+=P$7%G!<%?I=%"%I%l%9(B	*/
    dword	labellen;	/* $B8+=P$7%G!<%?I=%5%$%:(B		*/
} INFPAGEHDR;

/*
 * $BK\J8Fb$NI=<(B0@->pJs$r5-=R$7$?I=(B
 */
typedef	struct {
    uchr	off[4];		/* $BB0@-J8;z%*%U%;%C%H(B		*/
    uchr	len[4];		/* $BB0@-J8;z%5%$%:(B		*/
    uchr	attr[4];	/* $BJ8;zB0@-(B			*/
} INFATTRTBL;

/*
 * $BK\J8Fb$+$i30$K%j%s%/$5$l$k>pJs$r5-=R$7$?I=(B
 */
typedef	struct {
    uchr	off[4];		/* $B%j%s%/@_DjJ8;z%*%U%;%C%H(B	*/
    uchr	len[4];		/* $B%j%s%/@_DjJ8;z%5%$%:(B		*/
    uchr	type[4];	/* $B%j%s%/%?%$%W(B			*/
    uchr	page[4];	/* $B%j%s%/@h%Z!<%8(B		*/
    uchr	idx[4];		/* $B%j%s%/@h8+=P$7MWAGHV9f(B	*/
} INFLINKTBL;

/*
 * $B8+=P$7HV9f$HK\J8%G!<%?(B(DAT$B%U%!%$%kFb(B)$B$H$NBP1~I=(B
 */
typedef	struct {
    uchr	idx[4];		/* $B8+=P$7MWAGHV9f(B		*/
    uchr	off[4];		/* $BK\J8%Z!<%8Fb%*%U%;%C%H(B	*/
    uchr	len[4];		/* $BK\J8%5%$%:(B			*/
} INFIDXTBL;

/*
 * $B8+=P$7J8;zNs$HK\J8%G!<%?(B(DAT$B%U%!%$%kFb(B)$B$H$NBP1~I=(B
 * INFIDXTBL$B$H(BINFLABELTBL$B$OF1$88D?t$N9`L\$,F1$8=g$KJB$s$G$$$k(B
 */
typedef	struct {
    uchr	off[4];		/* $BK\J8%Z!<%8Fb%*%U%;%C%H(B	*/
    uchr	unknown[4];	/* ($B>o$K(B0?)			*/
    uchr	label[256];	/* $B8+=P$7J8;zNs(B			*/
} INFLABELTBL;

char	*inffile;	/* INF$B%U%!%$%kL>(B			*/
int	inffd = -1;	/* INF$B%U%!%$%k5-=R;R(B			*/
INFHDR	infhdr;		/* INF$B%U%!%$%k%X%C%@!<(B			*/
uchr	*infpage;	/* INF$B%Z!<%8(B				*/
dword	ipageaddr;	/* INF$B%Z!<%8$N%"%I%l%9(B			*/
dword	ipagelen;	/* INF$B%Z!<%8$N%5%$%:(B			*/

/*
 * inf_open - INF$B%U%!%$%k$r%*!<%W%s$9$k(B
 */
int
inf_open(file)
char	*file;
{
    int		i;
    dword	*p;

    if (inffd >= 0)
	return ERR;
    if (file == NULL) {
	sprintf(tmp, "%s: INF$B%U%!%$%k$,$"$j$^$;$s(B\n", progname);
	jc_outstr(tmp);
	return ERR;
    }
    if ((inffd = open(file, O_RDONLY|O_BINARY)) < 0) {
	sprintf(tmp, "%s: INF$B%U%!%$%k(B %s $B$,%*!<%W%s$G$-$^$;$s(B\n",
	    progname, file);
	jc_outstr(tmp);
	return ERR;
    }
    if (read(inffd, (char *)&infhdr, sizeof(infhdr)) < sizeof(infhdr)) {
	sprintf(tmp, "%s: INF$B%U%!%$%k%X%C%@!<$,FI$a$^$;$s(B\n", progname);
	jc_outstr(tmp);
	return ERR;
    }
    p = (dword *)&infhdr;
    for (i = 0; i < sizeof(infhdr) / sizeof(dword); i++)
	p[i] = dval(p[i]);
    inffile = strdup(file);
    infpage = malloc((size_t)INFPAGEMAX);
    if (infpage == NULL) {
	sprintf(tmp, "%s: $B%a%b%j!<$,B-$j$^$;$s(B\n", progname);
	jc_outstr(tmp);
	inf_close();
	return ERR;
    }
    return OK;
}

/*
 * inf_close - INF$B%U%!%$%k$r%/%m!<%:$9$k(B
 */
int
inf_close()
{
    if (inffd < 0)
	return ERR;
    if (close(inffd) < 0)
	return ERR;
    free(inffile);
    inffd = -1;
    inffile = NULL;
    if (infpage != NULL)
	free(infpage);
    infpage = NULL;
    return OK;
}

/*
 * inf_hdrinfo - INF$B%U%!%$%k%X%C%@!<$r%@%s%W$9$k(B
 */
int
inf_hdrinfo()
{
    if (inffd < 0)
	return ERR;
    jc_outstr("$B!T(BINF$B%X%C%@!<>pJs!U(B\n");
    sprintf(tmp, "   INF$B%U%!%$%kL>(B: %s\n", inffile);
    jc_outstr(tmp);
    sprintf(tmp, "   INF$B%Z!<%8Am?t(B: %lu\n", infhdr.pagenum);
    jc_outstr(tmp);
    printf("\n");
    return OK;
}

/*
 * inf_dumppage - $B;XDj$5$l$?%Z!<%8$NFbMF$r%@%s%W$9$k(B
 *		  $BI,MW$K1~$8$FK\J8%G!<%?(B(DAT$B%U%!%$%kFb(B)$B$b;2>H$9$k(B
 */
int
inf_dumppage(startpage, endpage)
dword	startpage, endpage;
{
    int		i, n, nn;
    dword	page;
    uchr	*p;
    INFPAGEHDR	*h;
    INFATTRTBL	*ap;
    INFLINKTBL	*lp;
    INFIDXTBL	*ip;
    INFLABELTBL	*bp;

    if (inffd < 0)
	return ERR;

    for (page = startpage; page <= endpage; page++) {
	if (inf_getpage(page) != OK)
	    return ERR;
	if (dat_getpage(page) != OK)
	    return ERR;
	jc_outstr("$B!T(BINF$B%Z!<%8%@%s%W!U(B\n");
	sprintf(tmp, "   INF$B%Z!<%8HV9f(B: %ld\n", (long)page);
	jc_outstr(tmp);
	sprintf(tmp, "     INF$B%Z!<%8D9(B: %ld\n", (long)ipagelen);
	jc_outstr(tmp);
	printf("\n");
	jc_outstr("$B!T(BINF$B%Z!<%8%X%C%@!<>pJs!U(B\n");
	h = (INFPAGEHDR *)infpage;
	sprintf(tmp, "      $BIUBS>pJsI=%"%I%l%9(B: %08lx\n", dval(h->iaddr));
	jc_outstr(tmp);
	sprintf(tmp, "      $BJ8;zB0@-I=%"%I%l%9(B: %08lx\n", dval(h->attraddr));
	jc_outstr(tmp);
	sprintf(tmp, "        $BJ8;zB0@-I=%5%$%:(B: %08lx\n", dval(h->attrlen));
	jc_outstr(tmp);
	sprintf(tmp, "    $B%j%s%/>pJsI=%"%I%l%9(B: %08lx\n", dval(h->linkaddr));
	jc_outstr(tmp);
	sprintf(tmp, "      $B%j%s%/>pJsI=%5%$%:(B: %08lx\n", dval(h->linklen));
	jc_outstr(tmp);
	sprintf(tmp, "    $B8+=P$7>pJsI=%"%I%l%9(B: %08lx\n", dval(h->idxaddr));
	jc_outstr(tmp);
	sprintf(tmp, "      $B8+=P$7>pJsI=%5%$%:(B: %08lx\n", dval(h->idxlen));
	jc_outstr(tmp);
	sprintf(tmp, "        $B%G!<%?I=%"%I%l%9(B: %08lx\n", dval(h->daddr));
	jc_outstr(tmp);
	sprintf(tmp, "  $B8+=P$7%G!<%?I=%"%I%l%9(B: %08lx\n", dval(h->labeladdr));
	jc_outstr(tmp);
	sprintf(tmp, "    $B8+=P$7%G!<%?I=%5%$%:(B: %08lx\n", dval(h->labellen));
	jc_outstr(tmp);
	printf("\n");
	if (dval(h->attrlen) > 0) {
	    jc_outstr("$B!TJ8;zB0@-I=!U(B\n");
	    jc_outstr("  $BK\J80LCV(B --$BD9$5(B-- --$BB0@-(B--\n");
	    ap = (INFATTRTBL *)(infpage + (dval(h->attraddr) - ipageaddr));
	    n = (int)(dval(h->attrlen) / sizeof(INFATTRTBL));
	    for (i = 0; i < n; i++) {
		printf("  %08lx %08lx %08lx",
		    sdval(ap[i].off), sdval(ap[i].len), sdval(ap[i].attr));
		switch ((int)sdval(ap[i].attr)) {
		case 0x01: p = "$BBg(B";	break;
		case 0x02: p = "$B@D(B";	break;
		case 0x03: p = "$B@V(B";	break;
		case 0x05: p = "$BNP(B";	break;
		case 0x64: p = "$B>.(B";	break;
		case 0x66: p = "$B>.@D(B";	break;
		}
		sprintf(tmp, "  \"%-.*s\"(%s)\n",
		    (int)(sdval(ap[i].len)), datpage + sdval(ap[i].off), p);
		jc_outstr(tmp);
	    }
	    printf("\n");
	}
	if (dval(h->linklen) > 0) {
	    jc_outstr("$B!T%j%s%/>pJsI=!U(B\n");
	    jc_outstr("  $BK\J80LCV(B --$BD9$5(B-- -$B%?%$%W(B- $B%j%s%/@h(B $BMWAGHV9f(B\n");
	    lp = (INFLINKTBL *)(infpage + (dval(h->linkaddr) - ipageaddr));
	    n = (int)(dval(h->linklen) / sizeof(INFLINKTBL));
	    for (i = 0; i < n; i++) {
		printf("  %08lx %08lx %08lx %08lx \"%-4.4s\"",
		    sdval(lp[i].off), sdval(lp[i].len), sdval(lp[i].type),
		    sdval(lp[i].page), lp[i].idx);
		sprintf(tmp, "  \"%-.*s\"\n",
		    (int)(sdval(lp[i].len)), datpage + sdval(lp[i].off));
		jc_outstr(tmp);
	    }
	    printf("\n");
	}
	if (dval(h->idxlen) > 0) {
	    jc_outstr("$B!T8+=P$7>pJs!&8+=P$7%G!<%?I=!U(B\n");
	    ip = (INFIDXTBL *)(infpage + (dval(h->idxaddr) - ipageaddr));
	    n = (int)(dval(h->idxlen) / sizeof(INFIDXTBL));
	    bp = (INFLABELTBL *)(infpage + (dval(h->labeladdr) - ipageaddr));
	    nn = (int)(dval(h->labellen) / sizeof(INFLABELTBL));
	    jc_outstr("  -$BHV9f(B- $BK\J80LCV(B --$BD9$5(B--");
	    if (nn > 0)
		jc_outstr(" $B8+=P$7(B");
	    printf("\n");
	    for (i = 0; i < n; i++) {
		printf("  \"%-4.4s\" %08lx %08lx",
		    ip[i].idx, sdval(ip[i].off), sdval(ip[i].len));
		if (nn > 0) {
		    sprintf(tmp, " %s", bp[i].label);
		    jc_outstr(tmp);
		}
		printf("\n");
	    }
	    printf("\n");
	}
    }
    return OK;
}

/*
 * inf_getpage - INF$B%U%!%$%k$+$i;XDj$5$l$?%Z!<%8$r<h$j=P$9(B
 */
int
inf_getpage(page)
dword	page;
{
    int		i;
    long	pos;
    size_t	len;
    dword	*p;
    INFPAGETBL	ipagetbl;
    static dword prevpage = FFFFFFFF;

    if (inffd < 0)
	return ERR;
    if (page == prevpage)
	return OK;
    if (page == 0 || page > infhdr.pagenum)
	return ERR;
    pos = (long)sizeof(INFPAGETBL) * (page - 1) + sizeof(INFHDR);
    if (lseek(inffd, pos, 0) < 0)
	return ERR;
    len = sizeof(INFPAGETBL);
    if (read(inffd, (char *)&ipagetbl, len) < len)
	return ERR;
    p = (dword *)&ipagetbl;
    for (i = 0; i < sizeof(ipagetbl) / sizeof(dword); i++)
	p[i] = dval(p[i]);
    ipageaddr = ipagetbl.pageaddr;
    ipagelen = ipagetbl.pagelen;
    if (ipagelen > (dword)INFPAGEMAX)
	return ERR;
    if (lseek(inffd, (long)ipageaddr, 0) < 0)
	return ERR;
    if (read(inffd, infpage, (size_t)ipagelen) < ipagelen)
	return ERR;
    prevpage = page;
    return OK;
}

/* ---------- DHLINK$B%U%!%$%kA`:n(B ---------- */

/*
 * DHLINK$B9`L\(B
 */
typedef	struct {
    uchr	fname[8];	/* $B4XO"%U%!%$%kL>4pK\It(B		*/
    dword	unknown1;	/* $BITL@(B				*/
    dword	unknown2;	/* $BITL@(B				*/
} DHLENT;

char	*dhlfile;	/* INF$B%U%!%$%kL>(B			*/
int	dhlfd = -1;	/* INF$B%U%!%$%k5-=R;R(B			*/

/*
 * dhl_open - DHLINK$B%U%!%$%k$r%*!<%W%s$9$k(B
 */
int
dhl_open(file)
char	*file;
{
    int		i;
    dword	*p;

    if (dhlfd >= 0)
	return ERR;
    if (file == NULL) {
	sprintf(tmp, "%s: DHLINK$B%U%!%$%k$,$"$j$^$;$s(B\n", progname);
	jc_outstr(tmp);
	return ERR;
    }
    if ((dhlfd = open(file, O_RDONLY|O_BINARY)) < 0) {
	sprintf(tmp, "%s: DHLINK$B%U%!%$%k(B %s $B$,%*!<%W%s$G$-$^$;$s(B\n",
	    progname, file);
	jc_outstr(tmp);
	return ERR;
    }
    inffile = strdup(file);
    return OK;
}

/*
 * dhl_close - DHLINK$B%U%!%$%k$r%/%m!<%:$9$k(B
 */
int
dhl_close()
{
    if (dhlfd < 0)
	return ERR;
    if (close(dhlfd) < 0)
	return ERR;
    free(dhlfile);
    dhlfd = -1;
    dhlfile = NULL;
    return OK;
}

/*
 * dhl_getentry - DHLINK$B%U%!%$%k$+$i;XDjHV9f$N9`L\$r<h$j=P$9(B
 */
int
dhl_getentry(entno, dhlentp)
dword	entno;
DHLENT	*dhlentp;
{
    long	pos;
    DHLENT	de;

    if (dhlfd < 0)
	return ERR;
    pos = (long)sizeof(DHLENT) * (entno - 1);
    if (lseek(dhlfd, pos, 0) < 0)
	return ERR;
    if (read(dhlfd, (char *)&de, sizeof(DHLENT)) < sizeof(DHLENT))
	return ERR;
    *dhlentp = de;
    return OK;
}

/* ---------- $B8eJ}0lCW%$%s%G%C%/%9:n@.(B ---------- */

uchr	*workfile1 = "work1.tmp";
uchr	*workfile2 = "work2.tmp";

#define	MODIFIED_KANA \
    "$B$!$#$%$'$)$,$.$0$2$4$6$8$:$<$>$@$B$C$E$G$I$P$Q$S$T$V$W$Y$Z$\$]$c$e$g(B"
#define	BASE_KANA \
    "$B$"$$$&$($*$+$-$/$1$3$5$7$9$;$=$?$A$D$D$F$H$O$O$R$R$U$U$X$X$[$[$d$f$h(B"

/*
 * normalize - $B%+%?%+%J!"CfE@!"%@!<%7$J$I$r4^$`8+=P$7J8;zNs$+$i(B
 *	       $B%$%s%G%C%/%9%-!<MQ$N$R$i$,$JJ8;zNs$r:n$k(B
 */
uchr *
normalize(str)
uchr	*str;
{
    register uchr *p, *s;
    static uchr	buf[128];

    s = str;
    p = buf;
    while (*s != '\0' && *s != '\n'
	&& !(*s == 0x81 && s[1] == 0x79)	/* $B!Z(B */
	&& !(*s == 0xf4 && s[1] == 0xae)) { 	/* $BGrH4$-$N!Z(B */
	if ((*s == 0x81 && s[1] == 0x5b)		/* $B!<(B */
	    || (*s == 0x82 && s[1] >= 0x9f && s[1] <= 0xf1) /* $B$R$i$,$J(B */
	    || (*s == 0x83 && s[1] == 0x94)) {		/* $B%t(B */
	    /*
	     * $B$R$i$,$J$HD92;$H!V%t!W$O$=$N$^$^%3%T!<(B
	     */
	    *p++ = *s++;
	    *p++ = *s++;
	    continue;
	}
	if (*s == 0x83 && s[1] >= 0x40 && s[1] <= 0x94) { /* $B%+%?%+%J(B */
	    /*
	     * $B%+%?%+%J$O$R$i$,$J$KJQ49$7$F%3%T!<(B
	     */
	    *p++ = 0x82;
	    s++;
	    if (*s >= 0x80)
		*p++ = *s++ + (0x9f - 0x40 - 1);
	    else
		*p++ = *s++ + (0x9f - 0x40);
	    continue;
	}
	/*
	 * $B$=$l0J30$NJ8;z$OFI$_<N$F(B
	 * ($BCfE@!"GrH4$-CfE@!"%@!<%7$@$1$G4A;z$O=P$F$3$J$$$O$:(B)
	 */
	s++;
	s++;
    }
    *p = '\0';
    return buf;
}

/*
 * reverse - $BJ8;zNs$+$i5U=g$NJ8;zNs$r:n$k(B
 */
uchr *
reverse(str)
register uchr *str;
{
    int		len;
    register uchr *p;
    static uchr	buf[128];

    len = strlen(str);
    p = buf;
    while (len > 0) {
	*p++ = str[len - 2];
	*p++ = str[len - 1];
	len -= 2;
    }
    *p = '\0';
    return buf;
}

/*
 * strpbrkw - 2$B%P%$%HJ8;z$I$&$7$N(Bstrpbrk
 */
uchr *
strpbrkw(s1, s2)
register uchr *s1;
uchr	*s2;
{
    register uchr *p;

    while (*s1) {
	for (p = s2; *p; p += 2) {
	    if (*s1 == *p && s1[1] == p[1])
		return s1;
	}
	s1 += 2;
    }
    return NULL;
}

#if 0
/*
 * basestr - $B$R$i$,$JJ8;zNs$+$i@62;$@$1$N$R$i$,$JJ8;zNs$r:n$k(B
 *	     ($B$R$i$,$JJ8;zNs$r<-=q=g$KJB$Y$k$?$a$N$b$N$@$,!"(B
 *	     $B<B:]$K$O;H$&I,MW$,$J$+$C$?(B)
 */
uchr *
basestr(str)
uchr	*str;
{
    register uchr *s, *t;
    int		n;
    uchr	*p;
    static uchr	buf[128];

    p = buf;
    for (s = str; *s; s += 2) {
	for (t = MODIFIED_KANA; *t; t += 2) {
	    if (*s == *t && s[1] == t[1])
		break;
	}
	if (*t) {
	    t = BASE_KANA + (t - MODIFIED_KANA);
	    *p++ = t[0];
	    *p++ = t[1];
	} else {
	    *p++ = s[0];
	    *p++ = s[1];
	}
    }
    *p = '\0';
    return buf;
}
#endif

/*
 * make_revidx - $B%*!<%W%s$5$l$?K\J8A0J}0lCW%$%s%G%C%/%9%U%!%$%k$+$i(B
 *		 $B;XDj$5$l$?L>A0$G8eJ}0lCW%$%s%G%C%/%9%U%!%$%k$r:n$k(B
 */
int
make_revidx(rxfile, step)
uchr	*rxfile;
int	step;
{
    int		i, j, k, n, fd, lastpage;
    int		pagenum, entnum, entlen, keylen;
    long	pos, npos;
    size_t	pagelen;
    time_t	t;
    dword	lstoff, lstidx, dpage, datoff;
    uchr	*p, *q, *key, *rev, *newpage;
    FILE	*fp;
    LSTENT	lstent;
    struct stat	st1, st2;

    t = time((time_t)0);
    if (step != 2) {
	pagelen = (size_t)(idxhdr.pagelen);
	entnum = (int)(idxhdr.entnum);
	entlen = (int)(idxhdr.entlen);
	keylen = (int)(idxhdr.keylen);
    }
    jc_outstr("$B!T8eJ}0lCW%$%s%G%C%/%9%U%!%$%k:n@.!U(B\n");
    if (step == 0 || step == 1) {
	jc_outstr("STEP1: $BA0J}0lCW%$%s%G%C%/%9$+$i5U=g%-!<%j%9%H$r@8@.$7$F$$$^$9(B...\n");
	if ((fp = fopen(workfile1, "w")) == NULL) {
	    sprintf(tmp, "%s: $B:n6H%U%!%$%k(B %s $B$,%*!<%W%s$G$-$^$;$s(B\n",
		progname, workfile1);
	    jc_outstr(tmp);
	    return ERR;
	}
	pos = (long)(idxhdr.hdrlen);
	for (i = 0; i < idxhdr.maxlevel - 1; i++)
	    pos += (long)pagelen * idxhdr.lpagenum[i];
	pagenum = (int)(idxhdr.lpagenum[idxhdr.maxlevel - 1]);
	for (i = 0; i < pagenum; i++) {
	    lseek(idxfd, pos, 0);
	    read(idxfd, (char *)idxpage, pagelen);
	    pos += pagelen;
	    p = idxpage;
	    for (j = 0; j < entnum; j++) {
		if (*p == 0xff)
		    break;
		if (p[keylen - 2] != 0x00) {
		    /*
		     * $B8+=P$7$ND9$5$,%-!<$N:GBgD9$rD6$($F$$$k$+$b$7$l$J$$(B
		     * LST$B%U%!%$%k$+$i<B:]$N8+=P$7$r<h$j=P$9(B
		     */
		    lstoff = sdval(p + keylen);
		    if (idx_getlstidx(lstoff, (dword)1, &lstidx) != OK) {
			fclose(fp);
			unlink(workfile1);
			return ERR;
		    }
		    if (lst_getentry(lstidx, &lstent) != OK) {
			fclose(fp);
			unlink(workfile1);
			return ERR;
		    }
		    if (strpbrkw(lstent.label, "\x81\x79\xf4\xae")) {
			/*
			 * LST$B%i%Y%kCf$K!V!Z!W$+GrH4$-$N!V!Z!W$,4^$^$l$k(B
			 * $B$D$^$j8+=P$7$NFI$_$O$3$NCf$G=*$o$C$F$$$k(B
			 */
			key = normalize(lstent.label);
		    } else {
			/*
			 * LST$B%i%Y%k$N:GBgD9$h$j8+=P$7$,D9$$$+$b$7$l$J$$(B
			 * DAT$B%U%!%$%k$+$i<B:]$N8+=P$7$r<h$j=P$9(B
			 */
			dpage = sdval(lstent.datpage);
			datoff = sdval(lstent.datoff);
			if (dat_getentry(dpage, datoff, databuf) != OK) {
			    fclose(fp);
			    unlink(workfile1);
			    return ERR;
			}
			key = normalize(databuf);
		    }
		} else {
		    key = p;
		}
		rev = reverse(key);
		for (q = rev; *q; q++)
		    fprintf(fp, "%02x", *q);
		fprintf(fp, " ");
		q = p + keylen;
		for (k = 0; k < 4; k++)
		    fprintf(fp, "%02x", *q++);
		fprintf(fp, " ");
		for (k = 0; k < 4; k++)
		    fprintf(fp, "%02x", *q++);
		fprintf(fp, "\n");
		p += entlen;
	    }
	}
	fclose(fp);
    }
    if (step == 0 || step == 2) {
	jc_outstr("STEP2: $B5U=g%-!<%j%9%H$r%=!<%H$7$F$$$^$9(B...\n");
	sprintf(tmp, "sort %s > %s", workfile1, workfile2);
	system(tmp);
	if (stat(workfile1, &st1) < 0 ||
	    stat(workfile2, &st2) < 0 ||
	    st1.st_size != st2.st_size) {
	    sprintf(tmp, "%s: $B%=!<%H$K<:GT$7$^$7$?(B\n", progname);
	    jc_outstr(tmp);
	    unlink(workfile1);
	    unlink(workfile2);
	    return ERR;
	}
	unlink(workfile1);
    }
    if (step == 0 || step == 3) {
	jc_outstr("STEP3: $B5U=g%-!<%j%9%H$+$i8eJ}0lCW%$%s%G%C%/%9$r9=C[$7$F$$$^$9(B...\n");
	newpage = malloc((size_t)pagelen);
	if (newpage == NULL) {
	    sprintf(tmp, "%s: $B%a%b%j!<$,B-$j$^$;$s(B\n", progname);
	    jc_outstr(tmp);
	    return ERR;
	}
	if ((fp = fopen(workfile2, "r")) == NULL) {
	    sprintf(tmp, "%s: $B:n6H%U%!%$%k(B %s $B$,%*!<%W%s$G$-$^$;$s(B\n",
		progname, workfile2);
	    jc_outstr(tmp);
	    free((char *)newpage);
	    return ERR;
	}
	if ((fd = open(rxfile, O_RDWR|O_CREAT|O_TRUNC|O_BINARY, 0644)) < 0) {
	    sprintf(tmp, "%s: $B%$%s%G%C%/%9%U%!%$%k(B %s $B$,?75,:n@.$G$-$^$;$s(B\n",
		progname, rxfile);
	    jc_outstr(tmp);
	    fclose(fp);
	    free((char *)newpage);
	    return ERR;
	}
	/*
	 * $BA0J}0lCW%$%s%G%C%/%9$+$i%X%C%@!<It$r%3%T!<(B
	 */
	lseek(idxfd, 0L, 0);
	read(idxfd, databuf, sizeof(IDXHDR));
	write(fd, databuf, sizeof(IDXHDR));
	/*
	 * $BA0J}0lCW%$%s%G%C%/%9$+$i(BLST$BMWAGHV9fI=$r%3%T!<(B
	 */
	lseek(idxfd, (long)(idxhdr.lsttbladdr), 0);
	lseek(fd, (long)(idxhdr.lsttbladdr), 0);
	while ((n = read(idxfd, databuf, (size_t)BUFSIZE)) > 0)
	    write(fd, databuf, (size_t)n);
	/*
	 * $B8eJ}0lCW%$%s%G%C%/%9$N:G2<CJ%Z!<%8$r9=C[(B
	 */
	pos = (long)(idxhdr.hdrlen);
	for (i = 0; i < idxhdr.maxlevel - 1; i++)
	    pos += (long)pagelen * idxhdr.lpagenum[i];
	lseek(fd, pos, 0);
	pagenum = (int)(idxhdr.lpagenum[idxhdr.maxlevel - 1]);
	for (i = 0; i < pagenum; i++) {
	    p = newpage;
	    for (j = 0; j < entnum; j++) {
		if (fgets(databuf, BUFSIZE, fp) == NULL)
		    break;
		q = databuf;
		for (k = 0; k < keylen; k++) {
		    if (*q == ' ')
			break;
		    *p++ = gethex(&q);
		}
		for (; k < keylen; k++)
		    *p++ = '\0';
		while (*q != ' ')
		    q++;
		q++;
		for (k = 0; k < 4; k++)
		    *p++ = gethex(&q);
		if (*q != ' ')
		    jc_outstr("ERR: $B:n6H%U%!%$%k$N9T7A<0$,IT@5$G$9(B\n");
		q++;
		for (k = 0; k < 4; k++)
		    *p++ = gethex(&q);
		if (*q != '\n')
		    jc_outstr("ERR: $B:n6H%U%!%$%k$N9T7A<0$,IT@5$G$9(B\n");
	    }
	    for (; j < entnum; j++) {
		for (k = 0; k < entlen; k++)
		    *p++ = 0xff;
	    }
	    if (p - newpage != (int)pagelen)
		jc_outstr("ERR: $B%Z!<%89=@.=hM}$K8m$j$,$"$j$^$9(B\n");
	    write(fd, (char *)newpage, (size_t)pagelen);
	}
	fclose(fp);
	/*
	 * $B:G2<CJ$h$j>e$N%$%s%G%C%/%9%Z!<%8$r=g<!9=C[(B
	 */
	for (i = idxhdr.maxlevel - 2; i >= 0; i--) {
	    pos = (long)(idxhdr.hdrlen);
	    for (j = 0; j < i; j++)
		pos += (long)pagelen * idxhdr.lpagenum[j];
	    pagenum = (int)(idxhdr.lpagenum[i]);
	    npos = pos + (long)pagelen * pagenum;
	    for (j = 0; j < pagenum; j++) {
		p = newpage;
		lseek(fd, npos, 0);
		lastpage = FALSE;
		for (k = 0; k < entnum && !lastpage; k++) {
		    if (read(fd, idxpage, pagelen) < pagelen)
			jc_outstr("ERR: $B?75,:n@.%U%!%$%k$+$i$N(Bread$B$K<:GT(B\n");
		    npos += pagelen;
		    q = idxpage + entlen * (entnum - 1);
		    if (*q == 0xff) {
			/*
			 * $B$3$NCJ$N:G=*%Z!<%8(B
			 */
			lastpage = TRUE;
			while (*q == 0xff)
			    q -= entlen;
		    }
		    memcpy((char *)p, (char *)q, (size_t)entlen);
		    p += entlen;
		}
		for (; k < entnum; k++) {
		    memset((char *)p, 0xff, (size_t)entlen);
		    p += entlen;
		}
		lseek(fd, pos, 0);
		write(fd, newpage, pagelen);
		pos += pagelen;
	    }
	}
	close(fd);
	unlink(workfile2);
	free((char *)newpage);
	sprintf(tmp, "$B8eJ}0lCW%$%s%G%C%/%9%U%!%$%k(B %s $B$,:n@.$5$l$^$7$?(B\n",
	    rxfile);
	jc_outstr(tmp);
    }
    n = time((time_t)0) - t;
    sprintf(tmp, "$B=hM}$,=*N;$7$^$7$?(B ($B7P2a;~4V(B: %d$BJ,(B%02d$BIC(B)\n", n/60, n%60);
    jc_outstr(tmp);
    printf("\n");
    return OK;
}

/* ---------- $BIt<sL>8!:w(B ---------- */

/*
 * $BIt<sHV9f:GBgCM(B
 */
#define	BNOMAX		285

/*
 * $BIt<s2h?t:GBgCM(B
 */
#define	BKAKUMAX	17

/*
 * $BL>A0!&HV9fBP1~I=(B
 */
typedef	struct {
    uchr	*name;
    int		bno;
} BUSHUTBL;

/*
 * $BIt<sL>!&It<sHV9fBP1~I=(B
 * (list/dl330.sls$B$NFbMF$K4p$E$/(B)
 */
BUSHUTBL bushutbl[] = {
    { "$B$"$*(B",			234 },
    { "$B$"$+(B",			207 },
    { "$B$"$5(B",			267 },
    { "$B$"$7(B",			209 },
    { "$B$"$J(B",			152 },
    { "$B$"$^$$(B",			131 },
    { "$B$"$_$,$7$i(B",		167 },
    { "$B$"$a(B",			232 },
    { "$B$"$a$+$s$`$j(B",		233 },
    { "$B$"$i$:(B",			235 },
    { "$B$$$7(B",			145 },
    { "$B$$$7$X$s(B",		146 },
    { "$B$$$?$k(B",			179 },
    { "$B$$$A(B",			  1 },
    { "$B$$$A$?(B",			100 },
    { "$B$$$H(B",			164 },
    { "$B$$$H$,$7$i(B",		 57 },
    { "$B$$$H$X$s(B",		165 },
    { "$B$$$L(B",			118 },
    { "$B$$$N$3(B",			203 },
    { "$B$$$k(B",			 12 },
    { "$B$$$m(B",			185 },
    { "$B$&$*(B",			261 },
    { "$B$&$*$X$s(B",		262 },
    { "$B$&$+$s$`$j(B",		 43 },
    { "$B$&$1$P$3(B",		 18 },
    { "$B$&$7(B",			117 },
    { "$B$&$8(B",			105 },
    { "$B$&$9(B",			180 },
    { "$B$&$^(B",			251 },
    { "$B$&$^$l$k(B",		132 },
    { "$B$&$j(B",			195 },
    { "$B$($s$K$g$&(B",		 59 },
    { "$B$*$$(B",			170 },
    { "$B$*$&$X$s(B",		129 },
    { "$B$*$*$,$$(B",		243 },
    { "$B$*$*$6$H(B",		216 },	/* $BM8(B */
    { "$B$*$*$6$H(B",		217 },	/* $BO:$N$D$/$j(B */
    { "$B$*$D(B",			  5 },
    { "$B$*$H(B",			242 },
    { "$B$*$K(B",			258 },
    { "$B$*$N$l(B",			 53 },
    { "$B$*$s$J(B",			 40 },
    { "$B$*$s$J$X$s(B",		 41 },
    { "$B$+$$(B",			205 },
    { "$B$+$$$X$s(B",		206 },
    { "$B$+$*$j(B",			249 },
    { "$B$+$/(B",			257 },
    { "$B$+$1$k(B",			 98 },
    { "$B$+$<(B",			244 },
    { "$B$+$?(B",			116 },
    { "$B$+$?$J(B",			 19 },
    { "$B$+$J$((B",			277 },
    { "$B$+$J$a$,$7$i(B",		194 },
    { "$B$+$M(B",			224 },
    { "$B$+$M$X$s(B",		225 },
    { "$B$+$N$[$3(B",		 78 },
    { "$B$+$_$,$7$i(B",		254 },
    { "$B$+$a(B",			284 },
    { "$B$+$i$$(B",			213 },
    { "$B$+$o(B",			 51 },	/* $BV_!"@n(B */
    { "$B$+$o(B",			239 },	/* $B3W(B */
    { "$B$+$o$X$s(B",		240 },
    { "$B$+$o$i(B",			130 },
    { "$B$+$s$K$g$&(B",		 18 },
    { "$B$,$s$@$l(B",		 28 },
    { "$B$-(B",			 96 },
    { "$B$-$$$m(B",			271 },
    { "$B$-$,$^$((B",		106 },
    { "$B$-$P(B",			154 },
    { "$B$-$S(B",			272 },
    { "$B$-$X$s(B",			 97 },
    { "$B$-$s(B",			 87 },
    { "$B$.$g$&(B",			191 },
    { "$B$.$g$&$K$s$Y$s(B",		 66 },
    { "$B$/$5(B",			186 },
    { "$B$/$A(B",			 31 },
    { "$B$/$A$X$s(B",		 32 },
    { "$B$/$K$,$^$((B",		 33 },
    { "$B$/$S(B",			248 },
    { "$B$/$i$Y$k(B",		103 },
    { "$B$/$k$^(B",			211 },
    { "$B$/$k$^$X$s(B",		212 },
    { "$B$/$m(B",			273 },
    { "$B$0$&$N$"$7(B",		149 },
    { "$B$1(B",			104 },
    { "$B$1$$$,$7$i(B",		 64 },
    { "$B$1$$$,$^$((B",		 14 },
    { "$B$1$$$5$s$+$s$`$j(B",	  8 },
    { "$B$1$b$N$X$s(B",		119 },
    { "$B$2$s(B",			127 },
    { "$B$3(B",			 42 },
    { "$B$3$3$m(B",			 76 },
    { "$B$3$6$H(B",			228 },
    { "$B$3$6$H$X$s(B",		229 },
    { "$B$3$H$P(B",			199 },
    { "$B$3$a(B",			162 },
    { "$B$3$a$X$s(B",		163 },
    { "$B$3$m$b(B",			192 },
    { "$B$3$m$b$X$s(B",		193 },
    { "$B$3$s(B",			184 },
    { "$B$4$s$Y$s(B",		200 },
    { "$B$5$1$N$H$j(B",		218 },
    { "$B$5$8(B",			 23 },
    { "$B$5$H(B",			221 },
    { "$B$5$`$i$$(B",		 36 },
    { "$B$5$i(B",			140 },
    { "$B$5$s$:$$(B",		108 },
    { "$B$5$s$E$/$j(B",		 65 },
    { "$B$7$+(B",			265 },
    { "$B$7$+$7$F(B",		171 },
    { "$B$7$+$P$M(B",		 47 },
    { "$B$7$-$,$^$((B",		 61 },
    { "$B$7$?(B",			181 },
    { "$B$7$a$9(B",			147 },
    { "$B$7$a$9$X$s(B",		148 },
    { "$B$7$g$&$X$s(B",		115 },
    { "$B$7$g$/(B",			246 },
    { "$B$7$g$/$X$s(B",		247 },
    { "$B$7$m(B",			138 },
    { "$B$7$s(B",			197 },
    { "$B$7$s$K$g$&(B",		215 },
    { "$B$8$e$&(B",			 25 },
    { "$B$8$e$&$^$?(B",		 82 },
    { "$B$9$G$N$D$/$j(B",		 89 },
    { "$B$9$s(B",			 44 },
    { "$B$;$$(B",			281 },
    { "$B$?(B",			134 },
    { "$B$?$+$$(B",			253 },
    { "$B$?$/$_(B",			 52 },
    { "$B$?$1(B",			161 },
    { "$B$?$D(B",			153 },	/* $BN)(B */
    { "$B$?$D(B",			214 },	/* $BC$(B */
    { "$B$?$K(B",			201 },
    { "$B$?$^(B",			128 },
    { "$B$@$$(B",			 39 },
    { "$B$A(B",			190 },	/* $B7l(B */
    { "$B$A(B",			274 },	/* $Bsc(B */
    { "$B$A$$$5$$(B",		 45 },
    { "$B$A$+$i(B",			 21 },
    { "$B$A$A(B",			113 },
    { "$B$A$g$&(B",			226 },	/* $BD9(B */
    { "$B$A$g$&(B",			256 },	/* $Br.(B */
    { "$B$D$-(B",			 93 },
    { "$B$D$-$X$s(B",		 94 },
    { "$B$D$/$((B",			 17 },
    { "$B$D$A(B",			 34 },
    { "$B$D$A$X$s(B",		 35 },
    { "$B$D$D$_$,$^$((B",		 22 },
    { "$B$D$E$_(B",			278 },
    { "$B$D$N(B",			198 },
    { "$B$D$a(B",			112 },
    { "$B$F(B",			 80 },
    { "$B$F$D(B",			 48 },
    { "$B$F$X$s(B",			 81 },
    { "$B$F$s(B",			  3 },
    { "$B$H$&(B",			255 },
    { "$B$H$S$i(B",			 79 },
    { "$B$H$V(B",			245 },
    { "$B$H$^$9(B",			 86 },
    { "$B$H$^$?(B",			 83 },
    { "$B$H$a$k(B",			 99 },
    { "$B$H$i(B",			187 },
    { "$B$H$j(B",			263 },
    { "$B$H$j$X$s(B",		219 },
    { "$B$J$+$l(B",			102 },
    { "$B$J$a$7$,$o(B",		259 },
    { "$B$K(B",			  7 },
    { "$B$K$/(B",			176 },
    { "$B$K$8$e$&$"$7(B",		 60 },
    { "$B$K$9$$(B",			 16 },
    { "$B$K$A(B",			 90 },
    { "$B$K$i(B",			241 },
    { "$B$K$s$K$g$&(B",		 11 },
    { "$B$K$s$Y$s(B",		 10 },
    { "$B$M$:$_(B",			279 },
    { "$B$N(B",			  4 },
    { "$B$N$.(B",			150 },
    { "$B$N$.$X$s(B",		151 },
    { "$B$N$4$a(B",			220 },
    { "$B$N$V$s(B",			 84 },
    { "$B$O(B",			282 },
    { "$B$O$3$,$^$((B",		 24 },
    { "$B$O$7$k(B",			208 },
    { "$B$O$A(B",			 13 },
    { "$B$O$D$,$7$i(B",		137 },
    { "$B$O$J(B",			280 },
    { "$B$O$M(B",			169 },
    { "$B$O$M$\$&(B",		  6 },
    { "$B$O$O(B",			102 },
    { "$B$O$P(B",			 54 },
    { "$B$O$P$X$s(B",		 55 },
    { "$B$R(B",			109 },
    { "$B$R$-(B",			135 },
    { "$B$R$D$8(B",			168 },
    { "$B$R$H(B",			  9 },
    { "$B$R$H$"$7(B",		 11 },
    { "$B$R$N$+$o(B",		139 },
    { "$B$R$X$s(B",			 91 },	/* $BF|!"[)!"5l!"C6(B */
    { "$B$R$X$s(B",			110 },	/* $B><!"L@(B */
    { "$B$R$i$S(B",			 92 },
    { "$B$U$7(B",			 27 },
    { "$B$U$G(B",			175 },
    { "$B$U$M(B",			183 },
    { "$B$U$f$,$7$i(B",		 37 },
    { "$B$U$k$H$j(B",		231 },
    { "$B$V$s(B",			 85 },
    { "$B$Y$s(B",			276 },
    { "$B$[$&(B",			 88 },
    { "$B$[$3(B",			143 },
    { "$B$[$9(B",			 56 },
    { "$B$[$H$.(B",			166 },
    { "$B$[$M(B",			252 },
    { "$B$\$&(B",			  2 },
    { "$B$\$/(B",			 26 },
    { "$B$^$2$"$7(B",		 46 },
    { "$B$^$9(B",			182 },
    { "$B$^$?(B",			 30 },
    { "$B$^$@$l(B",			 58 },
    { "$B$^$a(B",			202 },
    { "$B$_(B",			210 },
    { "$B$_$:(B",			107 },
    { "$B$_$:$+$i(B",		178 },
    { "$B$_$_(B",			173 },
    { "$B$_$_$X$s(B",		174 },
    { "$B$_$k(B",			196 },
    { "$B$`(B",			 29 },
    { "$B$`$.(B",			266 },
    { "$B$`$7(B",			188 },
    { "$B$`$7$X$s(B",		189 },
    { "$B$`$8$J(B",			204 },
    { "$B$a(B",			141 },
    { "$B$a$X$s(B",			142 },
    { "$B$a$a(B",			114 },
    { "$B$a$s(B",			238 },
    { "$B$b$A$$$k(B",		133 },
    { "$B$b$s(B",			227 },
    { "$B$d(B",			144 },
    { "$B$d$/(B",			285 },
    { "$B$d$^(B",			 49 },
    { "$B$d$^$$$@$l(B",		136 },
    { "$B$d$^$X$s(B",		 50 },
    { "$B$f$&$Y(B",			 38 },
    { "$B$f$_(B",			 62 },
    { "$B$f$_$X$s(B",		 63 },
    { "$B$h$D$F$s(B",		111 },
    { "$B$i$$$9$-(B",		172 },
    { "$B$j$C$7$s$Y$s(B",		 77 },
    { "$B$j$C$H$&(B",		 20 },
    { "$B$j$e$&(B",			283 },
    { "$B$k$^$?(B",			101 },
    { "$B$l$$$E$/$j(B",		230 },
    { "$B$m(B",			264 },
    { "$B$o$+$s$`$j(B",		 15 }
};

int
bushu_search(str, bnamep)
uchr	*str, **bnamep;
{
    int		i, n, bno, len;
    uchr	*p;
    static uchr	bnbuf[32];

    if (str == NULL)
	return ERR;
    n = sizeof(bushutbl) / sizeof(bushutbl[0]);
    if (*str == '.') {
	bno = atoi(str + 1);
	for (i = 0; i < n; i++) {
	    if (bushutbl[i].bno == bno) {
		*bnamep = strcpy(bnbuf, bushutbl[i].name);
		return bno;
	    }
	}
	return 0;
    }
    p = rk_getword(str);
    if (p == NULL)
	return 0;
    len = strlen(p);
    for (i = 0; i < n; i++) {
	if (compare(bushutbl[i].name, p, len) == 0) {
	    *bnamep = strcpy(bnbuf, bushutbl[i].name);
	    return bushutbl[i].bno;
	}
    }
    return 0;
}

/* ---------- $B<g=hM}(B ---------- */

/*
 * $B4A;z8!:w;~$NAm2h?t:GBgCM(B
 */
#define	SOKAKUMAX	33

/*
 * $B8!:wJ}<0(B
 */
#define	XMATCH		0	/* $B40A40lCW(B		*/
#define	NMATCH		1	/* $BA0J}0lCW(B		*/
#define	RMATCH		2	/* $B8eJ}0lCW(B		*/

/*
 * $B<-=q%5%V%G%#%l%/%H%j!<(B
 */
#define	IDXDIR		"index"		/* $B8!:w%$%s%G%C%/%9(B		*/
#define	LSTDIR		"list"		/* $B%$%s%G%C%/%9(B/$B%G!<%?BP1~I=(B	*/
#define	DATDIR		"data"		/* $BK\J8%G!<%?(B			*/
#define	ADDRDIR		"addrp"		/* $BL$D4::(B			*/
#define	TBLDIR		"table"		/* $BL$D4::(B			*/
#define	FWORDDIR	"fword"		/* $B%U%j!<%o!<%I8!:w(B		*/
#define	FIFDIR		"multim/fractal" /* $B?^HG!&?'8+K\(B(FIF$B2hA|(B)	*/
#define	KNJDIR		"multim/knj"	/* $B4A;z$N=q$-=g(B(QT$B%`!<%S!<(B)	*/
#define	MOVIEDIR	"multim/movie"	/* $BF02h!&F02h(B/$B2;@<(B		*/
#define	USEDIR		"multim/use"	/* $BBg<-@t$N;H$$J}(B		*/

/*
 * $B%j%s%/%?%$%W(B
 */
#define	LT_FIF		(dword)0x4e21	/* $B?^HG!"?'8+K\(B			*/
#define	LT_MOVIE	(dword)0x7531	/* $BF02h!"F02h(B/$B2;@<!"=q$-=g(B	*/
#define	LT_USE		(dword)0x4e23	/* $B;H$$J}(B			*/

/*
 * $B%^%k%A%a%G%#%"BP1~I=%U%!%$%k(B
 */
#define	DHLINK01	"dhlink01.tbl"	/* $B?^HG!"?'8+K\(B			*/
#define	DHLINK02	"dhlink02.tbl"	/* $BF02h!"F02h(B/$B2;@<(B		*/
#define	DHLINK03	"dhlink03.tbl"	/* $B=q$-=g(B			*/
#define	DHLINK04	"dhlink04.tbl"	/* $B;H$$J}(B			*/

/*
 * $B%^%k%A%a%G%#%"%U%!%$%k3HD%;R(B
 */
#define	FIFEXT		"fif"
#define	MOVIEEXT	"mov"

/*
 * $B4A;z!VBg<-@t!WMQ%$%s%G%C%/%9%U%!%$%k(B
 */
#define	ONKUN_IDX	"db300000.idx"		/* $B2;71FI$_%$%s%G%C%/%9(B	*/
#define	SOKAKU_IDX	"dn310000.idx"		/* $BAm2h?t%$%s%G%C%/%9(B	*/
#define	BUSHU_IDX	"dn320000.idx"		/* $BIt<s%$%s%G%C%/%9(B	*/
#define	BUSHU_SLS2	"dl320.sls"		/* $BIt<s%j%9%H(B		*/
#define	BUSHU_SLS3	"dl330.sls"		/* $BIt<s%j%9%H(B($BIt<sFI$_(B)	*/
#define	ONKUN_LST	"d300000.lst"
#define	SOKAKU_LST	"d310000.lst"
#define	BUSHU_LST	"d320000.lst"
#define	KANJI_DAT	"dh02.dat"
#define	KANJI_INF	"dh02.inf"

/*
 * $BK\J88eJ}0lCW%$%s%G%C%/%9:n@.$KI,MW$J%U%!%$%k(B
 */
#define	MAIN_NIDX	"db100000.idx"
#define	MAIN_RIDX	"db110000.idx"
#define	MAIN_LST	"d100000.lst"
#define	MAIN_DAT	"dh01.dat"

/*
 * DAT/INF$B%U%!%$%k$NA*Br(B
 */
typedef	struct {
    uchr	*tag;
    uchr	*title;
    uchr	*datfile;
    uchr	*inffile;
} DATLIST;

/*
 * $BK\J8%G!<%?(B
 */
DATLIST datlist[] = {
    { "1", "$BBg<-@tK\J8(B",     "dh01.dat", "dh01.inf" },
    { "2", "$B4A;z!VBg<-@t!W(B", "dh02.dat", "dh02.inf" },
    { "3", "$BBg<-@t$N;H$$J}(B", "dh03.dat", "dh03.inf" },
    { "4", "$BK^Nc(B",           "dh04.dat", "dh04.inf" },
    { "5", "$B=x(B",             "dh05.dat", "dh05.inf" },
    { "6", "$B1|IU(B",           "dh06.dat", "dh06.inf" }
};

/*
 * $BBg<-@tK\J8$KBP$9$k(BIDX/LST$B%U%!%$%k$NA*Br(B
 */
typedef	struct {
    uchr	*tag;
    uchr	*title;
    uchr	*nidxfile;
    uchr	*nlstfile;
    uchr	*ridxfile;
    uchr	*rlstfile;
} IDXLIST;

/*
 * $BBg<-@tK\J8$N%$%s%G%C%/%9(B
 */
IDXLIST idxlist[] = {
    { "1",   "$B$^$k$4$H(B",	     "db100000.idx","d100000.lst",
					"db110000.idx","d100000.lst"},
    { "2.0", "$B>.I42J(B/$BJ83X(B",	     "db200000.idx","d200000.lst",NULL,NULL},
    { "2.1", "$B>.I42J(B/$BF|K\;K(B",	     "db200100.idx","d200100.lst",NULL,NULL},
    { "2.2", "$B>.I42J(B/$B@$3&;K(B",	     "db200200.idx","d200200.lst",NULL,NULL},
    { "2.3", "$B>.I42J(B/$BE/3X(B",	     "db200300.idx","d200300.lst",NULL,NULL},
    { "2.4", "$B>.I42J(B/$B=!65(B",	     "db200400.idx","d200400.lst",NULL,NULL},
    { "2.5", "$B>.I42J(B/$B<R2q(B",	     "db200500.idx","d200500.lst",NULL,NULL},
    { "2.6", "$B>.I42J(B/$B2;3Z(B",	     "db200600.idx","d200600.lst",NULL,NULL},
    { "2.7", "$B>.I42J(B/$BH~=Q(B",	     "db200700.idx","d200700.lst",NULL,NULL},
    { "2.8", "$B>.I42J(B/$B1i7`!&1G2h(B",    "db200800.idx","d200800.lst",NULL,NULL},
    { "2.9", "$B>.I42J(B/$BJ*M}!&2J3X(B",    "db200900.idx","d200900.lst",NULL,NULL},
    { "2.10","$B>.I42J(B/$B@8J*(B",	     "db201000.idx","d201000.lst",NULL,NULL},
    { "2.11","$B>.I42J(B/$BCO3X(B",	     "db201100.idx","d201100.lst",NULL,NULL},
    { "2.12","$B>.I42J(B/$B0e3X(B",	     "db201200.idx","d201200.lst",NULL,NULL},
    { "2.13","$B>.I42J(B/$BCOM}(B",	     "db201300.idx","d201300.lst",NULL,NULL},
    { "2.14","$B>.I42J(B/$B@83h(B",	     "db201400.idx","d201400.lst",NULL,NULL},
    { "4.0", "$B:P;~5-(B/$B?7G/(B",	     "db400000.idx","d400000.lst",NULL,NULL},
    { "4.1", "$B:P;~5-(B/$B=U(B",	     "db400100.idx","d400100.lst",NULL,NULL},
    { "4.2", "$B:P;~5-(B/$B2F(B",	     "db400200.idx","d400200.lst",NULL,NULL},
    { "4.3", "$B:P;~5-(B/$B=)(B",	     "db400300.idx","d400300.lst",NULL,NULL},
    { "4.4", "$B:P;~5-(B/$BE_(B",	     "db400400.idx","d400400.lst",NULL,NULL},
    { "4.5", "$B:P;~5-(B/$BA45(@a(B",	     "db400500.idx","d400500.lst",NULL,NULL},
    { "5.0", "$B$3$H$o$6(B/$B0lMw(B",	     "db500000.idx","d500000.lst",NULL,NULL},
    { "5.1", "$B$3$H$o$6(B/$B%-!<%o!<%I(B",  "db510000.idx","d500000.lst",NULL,NULL},
    { "6.0", "$B;M;z=O8l(B/$BFI$_(B",	     "db600000.idx","d600000.lst",NULL,NULL},
    { "6.1", "$B;M;z=O8l(B/$B=gITF1(B",	     "db600100.idx","d600000.lst",NULL,NULL},
    { "6.2", "$B;M;z=O8l(B/$B0l;zL\(B",	     "db600200.idx","d600000.lst",NULL,NULL},
    { "6.3", "$B;M;z=O8l(B/$BFs;zL\(B",	     "db600300.idx","d600000.lst",NULL,NULL},
    { "6.4", "$B;M;z=O8l(B/$B;0;zL\(B",	     "db600400.idx","d600000.lst",NULL,NULL},
    { "6.5", "$B;M;z=O8l(B/$B;M;zL\(B",	     "db600500.idx","d600000.lst",NULL,NULL},
    { "7",   "$B%+%?%+%J(B",	     "db700000.idx","d700000.lst",
					"db710000.idx","d710000.lst"},
    { "8",   "ABC",		     "db800000.idx","d800000.lst",NULL,NULL},
    { "9.0", "$B%^%k%A%a%G%#%"(B/$B@E;_2h(B","db900000.idx","d900000.lst",NULL,NULL},
    { "9.1", "$B%^%k%A%a%G%#%"(B/$BF02h(B",  "db900100.idx","d900100.lst",NULL,NULL},
    { "9.2", "$B%^%k%A%a%G%#%"(B/$B2;@<(B",  "db900200.idx","d900200.lst",NULL,NULL},
    { "9.3", "$B%^%k%A%a%G%#%"(B/$B=q$-=g(B","db900300.idx","d900300.lst",NULL,NULL},
    { "9.4", "$B%^%k%A%a%G%#%"(B/$B?'(B",    "db900400.idx","d900400.lst",NULL,NULL},
    { "9.5", "$B%^%k%A%a%G%#%"(B/$B0lMw(B",  "db900500.idx","d900500.lst",NULL,NULL}
};

int	datno = 0;
int	idxno = 0;
int	debug = 0;
int	verbose = FALSE;
int	startpage = 0;
int	endpage = 0;
int	mkrevidx = FALSE;
int	mkrevstep = 0;
int	idxonly = FALSE;
int	revidx = FALSE;
int	listonly = FALSE;
int	bushuonly = FALSE;
int	printall = FALSE;
uchr	**dicpath = NULL;

uchr	*Nidxfile;		/* $BA0J}0lCW%$%s%G%C%/%9%U%!%$%k(B	*/
uchr	*Ridxfile;		/* $B8eJ}0lCW%$%s%G%C%/%9%U%!%$%k(B	*/
uchr	*Nlstfile;		/* $BA0J}0lCW%G!<%?BP1~I=%U%!%$%k(B	*/
uchr	*Rlstfile;		/* $B8eJ}0lCW%G!<%?BP1~I=%U%!%$%k(B	*/
uchr	*Sidxfile;		/* $B4A;z8!:wAm2h?t%$%s%G%C%/%9(B	*/
uchr	*Slstfile;		/* $B4A;z8!:wAm2h?t%G!<%?BP1~I=(B	*/
uchr	*Bidxfile;		/* $B4A;z8!:wIt<s2h?t%$%s%G%C%/%9(B	*/
uchr	*Blstfile;		/* $B4A;z8!:wIt<s%G!<%?BP1~I=(B	*/
uchr	*Sls2file;		/* $B4A;z8!:wIt<sHV9fBP1~I=(B	*/
uchr	*Sls3file;		/* $B4A;z8!:wIt<sHV9fBP1~I=(B	*/
uchr	*Datfile;		/* $BK\J8%G!<%?%U%!%$%k(B		*/
uchr	*Inffile;		/* $BK\J8IUBS>pJs%U%!%$%k(B		*/

/*
 * usage - $B;HMQK!$rI=<($7$F=*N;$9$k(B
 */
void
usage()
{
    sprintf(tmp, "$B>.3X4[Bg<-@t(BCD-ROM$B8!:w%f!<%F%#%j%F%#!<(B Ver.%s (%s)\n",
	version, date);
    jc_outstr(tmp);
    jc_outstr("    Written by Junn Ohta (ohta@src.ricoh.co.jp), Public Domain.\n");
    printf("\n");
    sprintf(tmp, "$B;HMQK!(B: %s -d<$B<-=q%Q%9(B>[,<$B<-=q%Q%9(B>...] [-g<$B30;z%U%!%$%k(B>]\n",
	progname);
    jc_outstr(tmp);
    jc_outstr("\t\t[-m<$B<oJL(B>] [-i<$B<oJL(B>] [-x] [-r] [-l] [-p] [-b] [-v]\n");
    jc_outstr("\t\t[-w<$B7e?t(B>] [-f<$B%9%F%C%W(B>]");
#ifdef UNIX
    jc_outstr(" [-c<$B%3!<%I(B>]");
#endif
    jc_outstr(" [$B8!:w;XDj(B ...]\n");
    jc_outstr("$B%*%W%7%g%s(B:\n");
    jc_outstr("    -d: $B<-=q8!:w%Q%9$r;XDj$9$k(B\n");
    jc_outstr("    -g: $B30;z%U%!%$%kL>$r;XDj$9$k(B\n");
    sprintf(tmp, "    -m<$B<oJL(B>: $B%a%K%e!<$r;XDj$9$k(B (%s -m$B$G0lMw$rI=<((B)\n",
	progname);
    jc_outstr(tmp);
    sprintf(tmp, "    -i<$B<oJL(B>: $BK\J88!:w%$%s%G%C%/%9$r;XDj$9$k(B (%s -i$B$G0lMw$rI=<((B)\n",
	progname);
    jc_outstr(tmp);
    jc_outstr("    -x/-r: $BA0J}(B/$B8eJ}8!:w%-!<0lMw$NI=<((B (-i$B$HAH$_9g$o$;$F;H$&(B)\n");
    jc_outstr("    -l: $B8+=P$70lMw$NI=<((B (-i$B$HAH$_9g$o$;$F;H$&(B)\n");
    jc_outstr("    -p: $BK\J8%G!<%?A4BN$NI=<((B (-m$B$HAH$_9g$o$;$F;H$&(B)\n");
    jc_outstr("    -b: $BIt<s0lMw$NI=<((B\n");
    jc_outstr("    -v: $B>\:YI=<((B\n");
    jc_outstr("    -w<$B7e?t(B>: $B=PNO9TI}(B (0:$B2~9T$J$7(B($BI8=`(B))\n");
    jc_outstr("    -f[<$B%9%F%C%W(B>]: $B8eJ}0lCW%$%s%G%C%/%9%U%!%$%k$r:n@.$9$k(B\n");
#ifdef UNIX
    jc_outstr("    -c<$B%3!<%I(B>: $BF|K\8l%3!<%I(B (-cj:JIS, -ce:EUC($BI8=`(B), -cs:$B%7%U%H(BJIS)\n");
#endif
    if (verbose || debug) {
	jc_outstr("    -z: $B%G%P%C%0>pJs(B\n");
	jc_outstr("        -zp: $BFbIt%Q%i%a!<%?!<@_Dj$rI=<($9$k(B\n");
	jc_outstr("        -zg: $B30;z%G!<%?$r%@%s%W$9$k(B\n");
	jc_outstr("        -zh: $B3F%U%!%$%k%X%C%@!<$rI=<($9$k(B\n");
	jc_outstr("        -zd<$B3+;O(B>[-<$B=*N;(B>]: DAT$B%U%!%$%k$N;XDj%Z!<%8$r%@%s%W$9$k(B\n");
	jc_outstr("        -zi<$B3+;O(B>[-<$B=*N;(B>]: INF$B%U%!%$%k$N;XDj%Z!<%8$r%@%s%W$9$k(B\n");
    }
    jc_outstr("$B8!:w;XDj(B:\n");
    jc_outstr("    <$BJ8;zNs(B>: $B40A40lCW(B, <$BJ8;zNs(B>*: $BA0J}0lCW(B, *<$BJ8;zNs(B>: $B8eJ}0lCW(B\n");
    jc_outstr("    <$B%Z!<%8(B>.<$B%*%U%;%C%H(B>: $B8+=P$70lMw$N=PNO7k2L$+$iI=<((B\n");
    jc_outstr("    (<$B2;71(B>|<$B4A;z(B>)/<$BAm2h?t(B>/(<$BIt<s2h?t(B>|<$BIt<sL>(B>|.<$BIt<sHV9f(B>): $B4A;z8!:w(B(-m2)\n");
    exit(1);
}

/*
 * parse_opt - $B4D6-JQ?t$^$?$O%3%^%s%I9T0z?t$G;XDj$5$l$?%*%W%7%g%s$r(B
 *	       $B2r@O$7$FI,MW$J@_Dj$r9T$&(B
 */
int
parse_opt(str)
uchr	*str;
{
    int		i, m, n, len;
    uchr	*s, **d;

    if (str == NULL || *str++ != '-')
	return ERR;
    switch (*str++) {
    case 'D':
    case 'd':
	if (!*str)
	    return ERR;
	if (dicpath != NULL) {
	    for (d = dicpath; *d; d++)
		free((char *)*d);
	    free((char *)dicpath);
	    dicpath = NULL;
	}
	n = 1;
	for (s = str; *s; s++) {
	    if (*s == ';' || *s == ',')
		n++;
	}
	dicpath = (uchr **)malloc(sizeof(uchr *) * (n + 1));
	n = 0;
	while ((s = strtok(str, ";,")) != NULL) {
	    len = strlen(s);
	    if (s[len - 1] == '/' || s[len - 1] == '\\')
		s[len - 1] = '\0';
	    dicpath[n++] = strdup(s);
	    str = NULL;
	}
	dicpath[n] = NULL;
	break;
    case 'G':
    case 'g':
	if (!*str)
	    return ERR;
	if (gaijifile != NULL)
	    free((char *)gaijifile);
	gaijifile = strdup(str);
	break;
    case 'C':
    case 'c':
	switch (*str) {
	case 'J':
	case 'j':
	    kcode = KC_JIS;
	    if (str[1] && str[2]) {
		jiskanji = str[1];
		jisalpha = str[2];
	    }
	    break;
	case 'E':
	case 'e':
	    kcode = KC_EUC;
	    break;
	case 'S':
	case 's':
	    kcode = KC_SJIS;
	    break;
	default:
	    return ERR;
	}
	break;
    case 'M':
    case 'm':
	n = sizeof(datlist) / sizeof(datlist[0]);
	for (i = 0; i < n; i++) {
	    if (!strcmp(str, datlist[i].tag))
		break;
	}
	if (i == n) {
	    jc_outstr("$B!T%a%K%e!<0lMw!U(B\n");
	    for (i = 0; i < n; i++) {
		sprintf(tmp, "  -m%-6s%s\n",
		    datlist[i].tag, datlist[i].title);
		jc_outstr(tmp);
	    }
	    printf("\n");
	    exit(1);
	}
	datno = i;
	break;
    case 'I':
    case 'i':
	n = sizeof(idxlist) / sizeof(idxlist[0]);
	m = 0;
	len = strlen(str);
	for (i = 0; i < n; i++) {
	    if (!strcmp(str, idxlist[i].tag))
		break;
	    if (!strncmp(str, idxlist[i].tag, len))
		m++;
	}
	if (i == n) {
	    jc_outstr("$B!T8!:w%$%s%G%C%/%90lMw!U(B\n");
	    for (i = 0; i < n; i++) {
		if (m > 0 && strncmp(str, idxlist[i].tag, len))
		    continue;
		sprintf(tmp, "  -i%-6s%s\n",
		    idxlist[i].tag, idxlist[i].title);
		jc_outstr(tmp);
	    }
	    printf("\n");
	    exit(1);
	}
	idxno = i;
	break;
    case 'V':
    case 'v':
	verbose = TRUE;
	break;
    case 'W':
    case 'w':
	if (!isdigit(*str))
	    return ERR;
	width = atoi(str);
	break;
    case 'X':
    case 'x':
	idxonly = TRUE;
	revidx = FALSE;
	break;
    case 'R':
    case 'r':
	idxonly = TRUE;
	revidx = TRUE;
    case 'L':
    case 'l':
	listonly = TRUE;
	break;
    case 'B':
    case 'b':
	bushuonly = TRUE;
	break;
    case 'P':
    case 'p':
	printall = TRUE;
	break;
    case 'F':
    case 'f':
	mkrevidx = TRUE;
	mkrevstep = 0;
	if (isdigit(*str))
	    mkrevstep = atoi(str);
	break;
    case 'Z':
    case 'z':
	debug = *str++;
	if (!debug)
	    debug = '0';
	if (isupper(debug))
	    debug = tolower(debug);
	if (debug == 'd' || debug == 'i') {
	    if (!isdigit(*str))
		return ERR;
	    startpage = endpage = atoi(str);
	    while (isdigit(*str))
		str++;
	    if (*str++ == '-' && isdigit(*str)) {
		endpage = atoi(str);
		if (endpage < startpage)
		    return ERR;
	    }
	}
	break;
    default:
	usage();
	break;
    }
    return OK;
}

/*
 * init_env - $B4D6-JQ?t(BDAIJISEN$B$G;XDj$5$l$?%*%W%7%g%s$r@_Dj$9$k(B
 */
int
init_env()
{
    int		n;
    uchr	*env, *s, **ep, **pp;

    if ((env = getenv("DAIJISEN")) == NULL)
	return OK;
    n = 1;
    for (s = env; *s; s++) {
	if (*s == ' ' || *s == '\t')
	    n++;
    }
    ep = (uchr **)malloc(sizeof(uchr *) * (n + 1));
    pp = ep;
    while ((s = strtok(env, " \t")) != NULL) {
	*pp++ = s;
	env = NULL;
    }
    *pp = NULL;
    for (pp = ep; *pp; pp++) {
	if (parse_opt(*pp) != OK) {
	    sprintf(tmp, "%s: $B4D6-JQ?t(B DAIJISEN $B$K%(%i!<$,$"$j$^$9(B(%s)\n",
		progname, *pp);
	    jc_outstr(tmp);
	    return ERR;
	}
    }
    free((char *)ep);
    return OK;
}

/*
 * mk_path - $B%G%#%l%/%H%j!<L>$H%U%!%$%kL>$+$i%Q%9L>$r:n$k(B
 */
uchr *
mk_path(dir, subdir, file)
uchr	*dir, *subdir, *file;
{
    int		len;
    uchr	*path;

    len = 0;
    if (dir != NULL)
	len += strlen(dir) + 1;
    len += strlen(subdir) + 1 + strlen(file);
    path = (uchr *)malloc(len + 1);
    if (path == NULL)
	return NULL;
    *path = '\0';
    if (dir != NULL) {
	strcat(path, dir);
	strcat(path, "/");
    }
    strcat(path, subdir);
    strcat(path, "/");
    strcat(path, file);
    return path;
}

/*
 * search_path - $B<-=q8!:w%Q%9$+$i%U%!%$%k$rC5$7!"(B
 *		 $B8+$D$+$C$?%Q%9L>$rJV$9(B
 */
uchr *
search_path(subdir, file)
uchr	*subdir, *file;
{
    uchr	**dp, *path;

    if (subdir == NULL || file == NULL)
	return NULL;
    if (dicpath == NULL)
	return NULL;
    for (dp = dicpath; *dp; dp++) {
	path = mk_path(*dp, subdir, file);
	if (access(path, 0) == 0)
	    return (uchr *)path;
	free((char *)path);
    }
    return NULL;
}

/*
 * getkey - $BJ8;zNs$+$i8!:wJ8;zNs(B($B:GBg(B20$B%P%$%H(B)$B$r:n$k(B
 *	    $BJ8;zNs$,!V(B*$B!W$+!V!v!W$G;O$^$C$F$$$l$P8eJ}0lCW8!:w!"(B
 *	    $B$3$l$i$NJ8;z$G=*$o$C$F$$$l$PA0J}0lCW8!:w(B
 *	    $B$I$A$i$G$b$J$1$l$P40A40lCW8!:w$N%U%i%0$rJV$9(B
 */
uchr *
getkey(str, rp)
uchr	*str;
int	*rp;
{
    int		i, len, retr;
    uchr	*p, *q;
    static uchr	buf[MAXKEYLEN + 1];

    if (str == NULL)
	return NULL;
    p = tosjis(str);
    len = strlen(p);
    if ((*p == '*' || *p == 0x81 && p[1] == 0x96) &&
        (p[len-1] == '*' || p[len-1] == 0x96 && p[len-2] == 0x81)) {
	sprintf(tmp, "%s: $BA0J}0lCW$H8eJ}0lCW$rF1;~$K;XDj$9$k$3$H$O$G$-$^$;$s(B\n\n",
	    progname);
	jc_outstr(tmp);
	return NULL;
    }
    if (*p == '*' || *p == 0x81 && p[1] == 0x96) {
	retr = RMATCH;
	if (*p == '*')
	    p = rk_getword(p + 1);
	else
	    p = rk_getword(p + 2);
	if (p == NULL)
	    goto err;
	len = strlen(p);
	if (len > MAXKEYLEN) {
	    p += len - MAXKEYLEN;
	    len = MAXKEYLEN;
	}
	q = buf;
	while (len >= 2) {
	    *q++ = p[len - 2];
	    *q++ = p[len - 1];
	    len -= 2;
	}
	*q = '\0';
    } else if (p[len-1] == '*' || p[len-1] == 0x96 && p[len-2] == 0x81) {
	retr = NMATCH;
	if (p[len - 1] == '*')
	    p[len - 1] = '\0';
	else
	    p[len - 2] = '\0';
	p = rk_getword(p);
	if (p == NULL)
	    goto err;
	len = strlen(p);
	if (len > MAXKEYLEN)
	    p[MAXKEYLEN] = '\0';
	strcpy(buf, p);
    } else {
	retr = XMATCH;
	p = rk_getword(p);
	if (p == NULL)
	    goto err;
	len = strlen(p);
	if (len > MAXKEYLEN)
	    p[MAXKEYLEN] = '\0';
	strcpy(buf, p);
    }
    if (*buf == '\0')
	return NULL;
    *rp = retr;
    return buf;
err:
    sprintf(tmp, "%s: $B8!:wJ8;zNs$K8m$j$,$"$j$^$9(B\n\n", progname);
    jc_outstr(tmp);
    return NULL;
}

/*
 * show_inf - [$B?^HG(B]$B%U%!%$%kL>$J$IIUBS>pJs$rI=<($9$k(B
 */
int
show_inf(dpage, doff, buf)
dword	dpage, doff;
uchr	*buf;
{
    int		i, c, n, nent, dhlentno;
    uchr	*p, *dhlink, *mmfile, *dir, *ext;
    dword	off;
    INFPAGEHDR	*h;
    INFLINKTBL	*ilp;
    DHLENT	dhlent;

    if (Inffile == NULL) {
	/*
	 * INF$B%U%!%$%k$,$J$1$l$P2?$b$7$J$$(B
	 */
	return ERR;
    }
    n = 0;
    p = buf;
    while (*p) {
	if (*p < 0x81) {
	    p++;
	    continue;
	}
	if (*p != 0xf7 || p[1] < 0xda || p[1] > 0xdf) {
	    p++;
	    p++;
	    continue;
	}
	off = doff + (p - buf);
	c = p[1];
	p++;
	p++;
	if (c == 0xda || c == 0xdf) {		/* [$B?^HG(B]$B!"(B[$B?'8+K\(B]	*/
	    dhlink = search_path(DATDIR, DHLINK01);
	    dir = FIFDIR;
	    ext = FIFEXT;
	} else if (c == 0xdb || c == 0xdc) {	/* [$BF02h(B]$B!"(B[$BF02h(B/$B2;@<(B]	*/
	    dhlink = search_path(DATDIR, DHLINK02);
	    dir = MOVIEDIR;
	    ext = MOVIEEXT;
	} else if (c == 0xdd) {			/* [$B=q$-=g(B]		*/
	    dhlink = search_path(DATDIR, DHLINK03);
	    dir = KNJDIR;
	    ext = MOVIEEXT;
	}
	if (inffd == -1 && inf_open(Inffile) != OK)
	    return ERR;
	if (inf_getpage(dpage) != OK) {
	    inf_close();
	    return ERR;
	}
	h = (INFPAGEHDR *)infpage;
	ilp = (INFLINKTBL *)(infpage + (dval(h->linkaddr) - ipageaddr));
	nent = (int)(dval(h->linklen)) / sizeof(INFLINKTBL);
	for (i = 0; i < nent; i++) {
	    if (sdval(ilp->off) == off)
		break;
	    ilp++;
	}
	if (i == nent)
	    continue;
	if (c == 0xda && sdval(ilp->type) == LT_USE) {
	    dhlink = search_path(DATDIR, DHLINK04);
	    dir = USEDIR;
	    ext = FIFEXT;
	}
	if (dhlink == NULL || dhl_open(dhlink) != OK) {
	    inf_close();
	    return ERR;
	}
	if (dhl_getentry(sdval(ilp->page), &dhlent) != OK) {
	    inf_close();
	    dhl_close();
	    continue;
	}
	sprintf(tmp, "%.8s.%s", dhlent.fname, ext);
	mmfile = search_path(dir, tmp);
	if (mmfile != NULL) {
	    sprintf(tmp, "%c%c: %s\n", 0xf7, c, mmfile);
	    jc_outstr(tmp);
	    n++;
	    free((char *)mmfile);
	}
	dhl_close();
    }
    if (n > 0)
	printf("\n");
    return OK;
}

/*
 * cleanup_inf - show_inf$B$N8e;OKv$r$9$k(B
 */
int
cleanup_inf()
{
    if (Inffile != NULL && inffd > 0)
	inf_close();
    return OK;
}

/*
 * retrieve - $BK\J8%G!<%?$+$iFI$_$G8!:w$9$k(B
 */
int
retrieve(str)
uchr	*str;
{
    int		i, nent, retr, flag;
    long	cnt;
    dword	*lstidxp, cand, dpnum, dpage, doff;
    uchr	*key, *xfile, *lfile, *nkey;
    LSTENT	lstent;

    key = getkey(str, &retr);
    if (key == NULL)
	usage();
    if (retr != RMATCH) {
	xfile = Nidxfile;
	lfile = Nlstfile;
    } else {
	xfile = Ridxfile;
	lfile = Rlstfile;
	if (xfile == NULL || lfile == NULL) {
	    sprintf(tmp, "%s: $B8eJ}0lCW8!:w%$%s%G%C%/%9$,$"$j$^$;$s(B\n",
		progname);
	    jc_outstr(tmp);
	    return ERR;
	}
    }
    if (idx_open(xfile) != OK ||
	!idxonly && lst_open(lfile) != OK ||
	!idxonly && !listonly && dat_open(Datfile) != OK) {
	return ERR;
    }
    if (verbose) {
	sprintf(tmp,
	    "$B!T%G!<%?(B=%s, $B%$%s%G%C%/%9(B=%s, $B>r7o(B=%s, $B8!:w8l(B=%s%s$B!U(B\n\n",
	    datlist[datno].title, idxlist[idxno].title,
	    (retr == XMATCH)? "$B40A40lCW(B":
		(retr == NMATCH)? "$BA0J}0lCW(B": "$B8eJ}0lCW(B",
	    key,
	    idxonly? ", $B=hM}(B=$B8!:w%-!<0lMw(B":
	    listonly? ", $B=hM}(B=$B8+=P$70lMw(B": "");
	jc_outstr(tmp);
	if (idxonly) {
	    jc_outstr("$B8!:w%-!<(B ($B8uJd?t(B)\n");
	} else if (listonly) {
	    sprintf(tmp, "%-*s\t%s\n", MAXLABELLEN, "$B8+=P$7(B", "$B%Z!<%80LCV(B");
	    jc_outstr(tmp);
	}
    }
    cnt = 0L;
    switch (retr) {
    case XMATCH:
	if (idx_retrieve(key, &lstidxp, &cand) == OK) {
	    if (idxonly) {
		sprintf(tmp, "%s (%ld)\n", key, (long)cand);
		jc_outstr(tmp);
		cnt++;
		break;
	    }
	    for (i = 0; i < (int)cand; i++) {
		if (lst_getentry(lstidxp[i], &lstent) != OK) {
		    sprintf(tmp, "LST: \"%s\"$B$,8+$D$+$j$^$;$s(B\n", key);
		    jc_outstr(tmp);
		    break;
		}
		dpnum = sdval(lstent.datpnum);
		if (dpnum == FFFFFFFF) {
		    dpage = sdval(lstent.datpage);
		    doff = sdval(lstent.datoff);
		} else {
		    dpage = dpnum;
		    doff = (dword)0;
		}
		if (listonly) {
		    sprintf(tmp, "%-*s\t%ld.%ld\n",
			MAXLABELLEN, lstent.label, (long)dpage, (long)doff);
		    jc_outstr(tmp);
		    continue;
		}
		if (dat_getentry(dpage, doff, databuf) != OK) {
		    sprintf(tmp, "DAT: \"%s\"$B$,8+$D$+$j$^$;$s(B\n",
			lstent.label);
		    jc_outstr(tmp);
		    continue;
		}
		jc_output(databuf);
		printf("\n");
		show_inf(dpage, doff, databuf);
	    }
	    cnt += (long)cand;
	    free((char *)lstidxp);
	}
	break;
    case NMATCH:
    case RMATCH:
	flag = RETR_FIRST;
	while (idx_retrieve2(key, flag, &nkey, &lstidxp, &cand) == OK) {
	    flag = RETR_NEXT;
	    if (idxonly) {
		sprintf(tmp, "%s (%ld)\n", nkey, (long)cand);
		jc_outstr(tmp);
		cnt++;
		continue;
	    }
	    for (i = 0; i < (int)cand; i++) {
		if (lst_getentry(lstidxp[i], &lstent) != OK) {
		    sprintf(tmp, "LST: \"%s\"$B$,8+$D$+$j$^$;$s(B\n", key);
		    jc_outstr(tmp);
		    continue;
		}
		dpnum = sdval(lstent.datpnum);
		if (dpnum == FFFFFFFF) {
		    dpage = sdval(lstent.datpage);
		    doff = sdval(lstent.datoff);
		} else {
		    dpage = dpnum;
		    doff = (dword)0;
		}
		if (listonly) {
		    sprintf(tmp, "%-*s\t%ld.%ld\n",
			MAXLABELLEN, lstent.label, (long)dpage, (long)doff);
		    jc_outstr(tmp);
		    continue;
		}
		if (dat_getentry(dpage, doff, databuf) != OK) {
		    sprintf(tmp, "DAT: \"%s\"$B$,8+$D$+$j$^$;$s(B\n",
			lstent.label);
		    jc_outstr(tmp);
		    continue;
		}
		jc_output(databuf);
		printf("\n");
		show_inf(dpage, doff, databuf);
	    }
	    cnt += (long)cand;
	    free((char *)lstidxp);
	}
	break;
    }
    if ((idxonly || listonly) && cnt > 0)
	printf("\n");
    if (verbose) {
	sprintf(tmp, "%ld$B7o$N7k2L$,I=<($5$l$^$7$?(B\n\n", cnt);
	jc_outstr(tmp);
    }
    idx_close();
    if (!idxonly) {
	lst_close();
	if (!listonly) {
	    dat_close();
	    cleanup_inf();
	}
    }
    return OK;
}

/*
 * knj_retrieve - $B4A;z!VBg<-@t!W%G!<%?$+$i8!:w$9$k(B
 */
int
knj_retrieve(str)
uchr	*str;
{
    int		i, j, retr, flag, cnt;
    int		sokaku, bkaku, bushu, knj;
    int		knum, snum, bnum;
    dword	*lstidxp, *blstidxp, cand, bcand, dpnum;
    uchr	*p, *nstr, *key, *nkey, *bname;
    LSTENT	*klp, *slp, *blp, lstent;

    key = NULL;
    knj = FALSE;
    sokaku = 0;
    bkaku = 0;
    bushu = 0;
    nstr = strdup(str);
    if ((p = strchr(nstr, '/')) != NULL) {
	*p++ = '\0';
	sokaku = atoi(p);
	if (sokaku < 0 || sokaku > SOKAKUMAX)
	    usage();
	if ((p = strchr(p, '/')) != NULL) {
	    *p++ = 0;
	    if (isdigit(*p)) {
		bkaku = atoi(p);
		if (bkaku < 0 || bkaku > BKAKUMAX)
		    usage();
	    } else {
		bushu = bushu_search(p, &bname);
		if (bushu <= 0 || bushu > BNOMAX)
		    usage();
	    }
	}
    }
    if (*nstr)
	key = getkey(nstr, &retr);
    free((char *)nstr);
    if (key == NULL && sokaku == 0 && bkaku == 0 && bushu == 0)
	usage();
    if (key != NULL && retr == RMATCH)
	usage();
    if (key != NULL && *key >= 0x88) {
	/*
	 * $B4A;z$,D>@\;XDj$5$l$?(B
	 */
	knj = TRUE;
    }
    if (verbose) {
	jc_outstr("$B!T%G!<%?(B=$B4A;z!VBg<-@t!W(B");
	if (key != NULL) {
	    if (knj)
		sprintf(tmp, ", $B4A;z(B=%s", key);
	    else
		sprintf(tmp, ", $B2;71(B=%s, $B>r7o(B=%s",
		    key, (retr == XMATCH)? "$B40A40lCW(B": "$BA0J}0lCW(B");
	    jc_outstr(tmp);
	}
	if (sokaku > 0) {
	    sprintf(tmp, ", $BAm2h?t(B=%d", sokaku);
	    jc_outstr(tmp);
	}
	if (bkaku > 0) {
	    sprintf(tmp, ", $BIt<s2h?t(B=%d", bkaku);
	    jc_outstr(tmp);
	}
	if (bushu > 0) {
	    sprintf(tmp, ", $BIt<sL>(B=%s", bname);
	    jc_outstr(tmp);
	}
	jc_outstr("$B!U(B\n\n");
    }
    klp = slp = blp = NULL;
    knum = snum = bnum = 0;
    /*
     * $B4A;zD>@\;XDj(B(idxonly$B$O0UL#$,$J$$(B)
     */
    if (key != NULL && knj == TRUE) {
	if (lst_open(Blstfile) != OK)
	    return ERR;
	cnt = 0;
	flag = READ_FIRST;
	while (lst_readentry(flag, &lstent) == OK) {
	    if (lstent.label[0] == key[0] && lstent.label[1] == key[1]) {
		cnt++;
		break;
	    }
	    flag = READ_NEXT;
	}
	if (cnt > 0) {
	    klp = (LSTENT *)malloc(sizeof(LSTENT) * (size_t)cnt);
	    if (klp == NULL)
		return ERR;
	    klp[knum++] = lstent;
	    if (listonly) {
		sprintf(tmp, "%-*s\t%s\n",
		    MAXLABELLEN, "$B8+=P$7(B", "$B%Z!<%80LCV(B");
		jc_outstr(tmp);
		dpnum = sdval(klp[0].datpnum);
		sprintf(tmp, "%-*s\t-m2 %ld.0\n",
		    MAXLABELLEN, klp[0].label, (long)dpnum);
		jc_outstr(tmp);
		printf("\n");
		if (verbose) {
		    sprintf(tmp, "%d$B7o$N7k2L$,I=<($5$l$^$7$?(B\n\n", cnt);
		    jc_outstr(tmp);
		}
	    }
	}
	lst_close();
    }
    /*
     * $B2;71$NFI$_$G;XDj(B
     */
    if (key != NULL && knj == FALSE) {
	if (idx_open(Nidxfile) != OK ||
	    !idxonly && lst_open(Nlstfile) != OK) {
	    return ERR;
	}
	if (idxonly) {
	    jc_outstr("$B8!:w%-!<(B ($B8uJd?t(B)\n");
	} else if (listonly) {
	    sprintf(tmp, "%-*s\t%s\n",
		MAXLABELLEN, "$B8+=P$7(B", "$B%Z!<%80LCV(B");
	    jc_outstr(tmp);
	}
	cnt = 0;
	switch (retr) {
	case XMATCH:
	    if (idx_retrieve(key, &lstidxp, &cand) == OK) {
		if (idxonly) {
		    sprintf(tmp, "%s (%ld)\n", key, (long)cand);
		    jc_outstr(tmp);
		    cnt++;
		    free((char *)lstidxp);
		    break;
		}
		klp = (LSTENT *)malloc(sizeof(LSTENT) * (size_t)cand);
		if (klp == NULL) {
		    free((char *)lstidxp);
		    break;
		}
		for (i = 0; i < (int)cand; i++) {
		    if (lst_getentry(lstidxp[i], &klp[i]) != OK) {
			sprintf(tmp, "LST: \"%s\"$B$,8+$D$+$j$^$;$s(B\n", key);
			jc_outstr(tmp);
			break;
		    }
		    if (listonly) {
			dpnum = sdval(klp[i].datpnum);
			sprintf(tmp, "%-*s\t-m2 %ld.0\n",
			    MAXLABELLEN, klp[i].label, (long)dpnum);
			jc_outstr(tmp);
		    }
		}
		free((char *)lstidxp);
		cnt += (int)cand;
	    }
	    knum = cnt;
	    break;
	case NMATCH:
	    /*
	     * $B$^$:<B:]$K8!:w$7$F8uJd?t$N9g7W$rF@$k(B
	     */
	    flag = RETR_FIRST;
	    while (idx_retrieve2(key, flag, &nkey, &lstidxp, &cand) == OK) {
		flag = RETR_NEXT;
		if (idxonly) {
		    sprintf(tmp, "%s (%ld)\n", nkey, (long)cand);
		    jc_outstr(tmp);
		    cnt++;
		} else {
		    cnt += (int)cand;
		}
		free((char *)lstidxp);
	    }
	    if (idxonly)
		break;
	    /*
	     * $B<!$K(BLST$BMWAG%G!<%?$rFI$_9~$`(B
	     */
	    klp = (LSTENT *)malloc(sizeof(LSTENT) * cnt);
	    if (klp == NULL)
		return ERR;
	    knum = 0;
	    flag = RETR_FIRST;
	    while (idx_retrieve2(key, flag, &nkey, &lstidxp, &cand) == OK) {
		flag = RETR_NEXT;
		for (i = 0; i < (int)cand; i++) {
		    if (lst_getentry(lstidxp[i], &lstent) != OK) {
			sprintf(tmp, "LST: \"%s\"$B$,8+$D$+$j$^$;$s(B\n", key);
			jc_outstr(tmp);
			continue;
		    }
		    klp[knum++] = lstent;
		    if (listonly) {
			dpnum = sdval(lstent.datpnum);
			sprintf(tmp, "%-*s\t-m2 %ld.0\n",
			    MAXLABELLEN, lstent.label, (long)dpnum);
			jc_outstr(tmp);
		    }
		}
		free((char *)lstidxp);
	    }
	    break;
	}
	if (idxonly || listonly) {
	    if (cnt > 0)
		printf("\n");
	    if (verbose) {
		sprintf(tmp, "%d$B7o$N7k2L$,I=<($5$l$^$7$?(B\n\n", cnt);
		jc_outstr(tmp);
	    }
	}
	idx_close();
	if (!idxonly)
	    lst_close();
    }
    /*
     * $BAm2h?t$G;XDj(B
     */
    if (sokaku > 0 && !idxonly) {
	if (dn_open(Sidxfile) != OK || lst_open(Slstfile) != OK) {
	    if (klp != NULL)
		free((char *)klp);
	    return ERR;
	}
	if (listonly) {
	    sprintf(tmp, "%-*s\t%s\n",
		MAXLABELLEN, "$B8+=P$7(B", "$B%Z!<%80LCV(B");
	    jc_outstr(tmp);
	}
	if (dn_retrieve((dword)sokaku, &lstidxp, &cand) == OK) {
	    if (cand == 0) {
		sprintf(tmp, "DN: $BAm2h?t(B%d$B$N9`L\$O$"$j$^$;$s(B\n", sokaku);
		jc_outstr(tmp);
		goto sdone;
	    }
	    slp = (LSTENT *)malloc(sizeof(LSTENT) * (size_t)cand);
	    if (slp == NULL) {
		free((char *)lstidxp);
		if (klp != NULL)
		    free((char *)klp);
		return ERR;
	    }
	    for (i = 0; i < (int)cand; i++) {
		if (lst_getentry(lstidxp[i], &lstent) != OK) {
		    sprintf(tmp, "LST: $BAm2h?t(B%d$B$N9`L\$,8+$D$+$j$^$;$s(B\n",
			sokaku);
		    jc_outstr(tmp);
		    continue;
		}
		slp[snum++] = lstent;
		if (listonly) {
		    dpnum = sdval(lstent.datpnum);
		    sprintf(tmp, "%-*s\t-m2 %ld.0\n",
			MAXLABELLEN, lstent.label, (long)dpnum);
		    jc_outstr(tmp);
		}
	    }
	    free((char *)lstidxp);
	}
    sdone:
	if (listonly) {
	    if (snum > 0)
		printf("\n");
	    if (verbose) {
		sprintf(tmp, "%d$B7o$N7k2L$,I=<($5$l$^$7$?(B\n\n", snum);
		jc_outstr(tmp);
	    }
	}
	dn_close();
	lst_close();
    }
    /*
     * $BIt<s2h?t$G;XDj(B
     */
    if (bkaku > 0 && !idxonly) {
	if (dn_open(Bidxfile) != OK ||
	    sls_open(Sls2file) != OK ||
	    lst_open(Blstfile) != OK) {
	    if (klp != NULL)
		free((char *)klp);
	    if (slp != NULL)
		free((char *)slp);
	    return ERR;
	}
	if (listonly) {
	    sprintf(tmp, "%-*s\t%s\n",
		MAXLABELLEN, "$B8+=P$7(B", "$B%Z!<%80LCV(B");
	    jc_outstr(tmp);
	}
	if (dn_retrieve((dword)bkaku, &lstidxp, &cand) == OK) {
	    if (cand == 0) {
		sprintf(tmp, "DN: $BIt<s2h?t(B%d$B$N9`L\$O$"$j$^$;$s(B\n", bkaku);
		jc_outstr(tmp);
		goto bdone;
	    }
	    for (i = 0; i < (int)cand; i++) {
		if (sls_retrieve(lstidxp[i], &blstidxp, &bcand) != OK) {
		    sprintf(tmp, "SLS: $BIt<s2h?t(B%d$B$N9`L\$,8+$D$+$j$^$;$s(B\n",
			bkaku);
		    jc_outstr(tmp);
		    continue;
		}
		free((char *)blstidxp);
		cnt += (int)bcand;
	    }
	    blp = (LSTENT *)malloc(sizeof(LSTENT) * (size_t)cnt);
	    if (blp == NULL) {
		free((char *)lstidxp);
		if (klp != NULL)
		    free((char *)klp);
		if (slp != NULL)
		    free((char *)slp);
		return ERR;
	    }
	    for (i = 0; i < (int)cand; i++) {
		if (sls_retrieve(lstidxp[i], &blstidxp, &bcand) != OK)
		    continue;
		for (j = 0; j < (int)bcand; j++) {
		    if (lst_getentry(blstidxp[j], &lstent) != OK)
			continue;
		    blp[bnum++] = lstent;
		    if (listonly) {
			dpnum = sdval(lstent.datpnum);
			sprintf(tmp, "%-*s\t-m2 %ld.0\n",
			    MAXLABELLEN, lstent.label, (long)dpnum);
			jc_outstr(tmp);
		    }
		}
		free((char *)blstidxp);
	    }
	    free((char *)lstidxp);
	}
    bdone:
	if (listonly) {
	    if (bnum > 0)
		printf("\n");
	    if (verbose) {
		sprintf(tmp, "%d$B7o$N7k2L$,I=<($5$l$^$7$?(B\n\n", bnum);
		jc_outstr(tmp);
	    }
	}
	dn_close();
	sls_close();
	lst_close();
    }
    /*
     * $BIt<sL>$"$k$$$OIt<sHV9f$G;XDj(B
     */
    if (bushu > 0 && !idxonly) {
	if (sls_open(Sls2file) != OK ||
	    lst_open(Blstfile) != OK) {
	    if (klp != NULL)
		free((char *)klp);
	    if (slp != NULL)
		free((char *)slp);
	    return ERR;
	}
	if (listonly) {
	    sprintf(tmp, "%-*s\t%s\n",
		MAXLABELLEN, "$B8+=P$7(B", "$B%Z!<%80LCV(B");
	    jc_outstr(tmp);
	}
	if (sls_retrieve((dword)bushu, &lstidxp, &cand) == OK) {
	    blp = (LSTENT *)malloc(sizeof(LSTENT) * (size_t)cand);
	    if (blp == NULL) {
		free((char *)lstidxp);
		if (klp != NULL)
		    free((char *)klp);
		if (slp != NULL)
		    free((char *)slp);
		return ERR;
	    }
	    for (i = 0; i < (int)cand; i++) {
		if (lst_getentry(lstidxp[i], &lstent) != OK) {
		    sprintf(tmp, "LST: $BIt<sHV9f(B%d$B$N9`L\$,8+$D$+$j$^$;$s(B\n",
			bushu);
		    jc_outstr(tmp);
		    continue;
		}
		blp[bnum++] = lstent;
		if (listonly) {
		    dpnum = sdval(lstent.datpnum);
		    sprintf(tmp, "%-*s\t-m2 %ld.0\n",
			MAXLABELLEN, lstent.label, (long)dpnum);
		    jc_outstr(tmp);
		}
	    }
	    free((char *)lstidxp);
	}
	if (listonly) {
	    if (bnum > 0)
		printf("\n");
	    if (verbose) {
		sprintf(tmp, "%d$B7o$N7k2L$,I=<($5$l$^$7$?(B\n\n", bnum);
		jc_outstr(tmp);
	    }
	}
	sls_close();
	lst_close();
    }
    if (!idxonly && !listonly) {
	cnt = 0;
	if (knum > 0 || snum > 0 || bnum > 0) {
	    if (dat_open(Datfile) != OK) {
		if (klp != NULL)
		    free((char *)klp);
		if (slp != NULL)
		    free((char *)slp);
		if (blp != NULL)
		    free((char *)blp);
		return ERR;
	    }
	    if (knum > 0) {
		for (i = 0; i < knum; i++) {
		    dpnum = sdval(klp[i].datpnum);
		    if (snum > 0) {
			for (j = 0; j < snum; j++) {
			    if (sdval(slp[j].datpnum) == dpnum)
				break;
			}
			if (j == snum)
			    continue;
		    }
		    if (bnum > 0) {
			for (j = 0; j < bnum; j++) {
			    if (sdval(blp[j].datpnum) == dpnum)
				break;
			}
			if (j == bnum)
			    continue;
		    }
		    if (dat_getentry(dpnum, (dword)0, databuf) != OK) {
			sprintf(tmp, "DAT: \"%s\"$B$,8+$D$+$j$^$;$s(B\n",
			    klp[i].label);
			jc_outstr(tmp);
			continue;
		    }
		    jc_output(databuf);
		    printf("\n");
		    show_inf(dpnum, (dword)0, databuf);
		    cnt++;
		}
	    } else if (snum > 0) {
		for (i = 0; i < snum; i++) {
		    dpnum = sdval(slp[i].datpnum);
		    if (bnum > 0) {
			for (j = 0; j < bnum; j++) {
			    if (sdval(blp[j].datpnum) == dpnum)
				break;
			}
			if (j == bnum)
			    continue;
		    }
		    if (dat_getentry(dpnum, (dword)0, databuf) != OK) {
			sprintf(tmp, "DAT: \"%s\"$B$,8+$D$+$j$^$;$s(B\n",
			    slp[i].label);
			jc_outstr(tmp);
			continue;
		    }
		    jc_output(databuf);
		    printf("\n");
		    show_inf(dpnum, (dword)0, databuf);
		    cnt++;
		}
	    } else if (bnum > 0) {
		for (i = 0; i < bnum; i++) {
		    dpnum = sdval(blp[i].datpnum);
		    if (dat_getentry(dpnum, (dword)0, databuf) != OK) {
			sprintf(tmp, "DAT: \"%s\"$B$,8+$D$+$j$^$;$s(B\n",
			    blp[i].label);
			jc_outstr(tmp);
			continue;
		    }
		    jc_output(databuf);
		    printf("\n");
		    show_inf(dpnum, (dword)0, databuf);
		    cnt++;
		}
	    }
	    dat_close();
	    cleanup_inf();
	}
	if (verbose) {
	    sprintf(tmp, "%d$B7o$N7k2L$,I=<($5$l$^$7$?(B\n\n", cnt);
	    jc_outstr(tmp);
	}
    }
    if (klp != NULL)
	free((char *)klp);
    if (slp != NULL)
	free((char *)slp);
    if (blp != NULL)
	free((char *)blp);
    return OK;
}

/*
 * showpagedata - $B%Z!<%8(B.$B%*%U%;%C%H;XDj$+$i%G!<%?$rI=<($9$k(B
 */
int
showpagedata(str)
uchr	*str;
{
    dword	dpage, doff;

    if (idxonly || listonly)
	return ERR;
    if (sscanf(str, "%ld.%ld", (long *)&dpage, (long *)&doff) != 2) {
	sprintf(tmp, "%s: $B%Z!<%8(B.$B%*%U%;%C%H;XDj$,@5$7$/$"$j$^$;$s(B\n",
	    progname);
	jc_outstr(tmp);
	return ERR;
    }
    if (dat_open(Datfile) != OK)
	return ERR;
    if (verbose) {
	sprintf(tmp, "$B!T%G!<%?(B=%s, $B=hM}(B=$B%Z!<%8I=<((B, $B0LCV(B=%s$B!U(B\n\n",
	    datlist[datno].title, str);
	jc_outstr(tmp);
    }
    if (dat_getentry(dpage, doff, databuf) != OK) {
	sprintf(tmp, "DAT: \"%s\"$B$,8+$D$+$j$^$;$s(B\n", str);
	jc_outstr(tmp);
	return ERR;
    }
    jc_output(databuf);
    printf("\n");
    show_inf(dpage, doff, databuf);
    dat_close();
    cleanup_inf();
    return OK;
}

/*
 * keylist - $B8!:w%-!<0lMw$r=PNO$9$k(B
 */
int
keylist()
{
    uchr	*ifile, *title;

    switch (datno) {
    case 0:	/* $BBg<-@tK\J8(B */
	if (revidx)
	    ifile = Ridxfile = search_path(IDXDIR, idxlist[idxno].ridxfile);
	else
	    ifile = Nidxfile = search_path(IDXDIR, idxlist[idxno].nidxfile);
	title = idxlist[idxno].title;
	break;
    case 1:	/* $B4A;z!VBg<-@t!W(B */
	ifile = search_path(IDXDIR, ONKUN_IDX);
	title = "$B2;71(B";
	break;
    default:
	jc_outstr("$B8!:w%$%s%G%C%/%9$O$"$j$^$;$s(B\n");
	return ERR;
    }
    if (idx_open(ifile) != OK)
	return ERR;
    if (verbose) {
	sprintf(tmp, "$B!T%G!<%?(B=%s, $B%$%s%G%C%/%9(B=%s, $B=hM}(B=$B8!:w%-!<0lMw!U(B\n\n",
	    datlist[datno].title, title);
	jc_outstr(tmp);
	jc_outstr("$B8!:w%-!<(B ($B8uJd?t(B)\n");
    }
    idx_dumpkey(verbose);
    idx_close();
    return OK;
}

/*
 * labellist - $B8+=P$7%G!<%?A4BN$r=PNO$9$k(B
 */
int
labellist()
{
    int		flag;
    long	cnt;
    uchr	*p, *title;
    dword	dpnum, dpage, doff;
    LSTENT	lstent;

    switch (datno) {
    case 0:	/* $BBg<-@tK\J8(B */
	Nlstfile = search_path(LSTDIR, idxlist[idxno].nlstfile);
	title = idxlist[idxno].title;
	break;
    case 1:	/* $B4A;z!VBg<-@t!W(B */
	Nlstfile = search_path(LSTDIR, ONKUN_LST);
	title = "$B2;71(B";
	break;
    default:
	jc_outstr("$B8!:w%$%s%G%C%/%9$O$"$j$^$;$s(B\n");
	return ERR;
    }
    if (lst_open(Nlstfile) != OK)
	return ERR;
    if (verbose) {
	sprintf(tmp, "$B!T%G!<%?(B=%s, $B%$%s%G%C%/%9(B=%s, $B=hM}(B=$B8+=P$70lMw!U(B\n\n",
	    datlist[datno].title, title);
	jc_outstr(tmp);
	sprintf(tmp, "%-*s\t%s\n", MAXLABELLEN, "$B8+=P$7(B", "$B%Z!<%80LCV(B");
	jc_outstr(tmp);
    }
    cnt = 0L;
    flag = READ_FIRST;
    while (lst_readentry(flag, &lstent) == OK) {
	dpnum = sdval(lstent.datpnum);
	if (dpnum == FFFFFFFF) {
	    dpage = sdval(lstent.datpage);
	    doff = sdval(lstent.datoff);
	    sprintf(tmp, "%-*s\t%ld.%ld\n",
		MAXLABELLEN, lstent.label, (long)dpage, (long)doff);
	} else {
	    sprintf(tmp, "%-*s\t-m2 %ld.0\n",
		MAXLABELLEN, lstent.label, (long)dpnum);
	}
	jc_outstr(tmp);
	flag = READ_NEXT;
	cnt++;
    }
    printf("\n");
    if (verbose) {
	sprintf(tmp, "%ld$B7o$N7k2L$,I=<($5$l$^$7$?(B\n\n", cnt);
	jc_outstr(tmp);
    }
    lst_close();
    return OK;
}

/*
 * bushulist - $BIt<s0lMw$r=PNO$9$k(B
 */
int
bushulist()
{
    int		flag, cnt;
    uchr	*p;
    dword	dpnum, dpage, doff;
    LSTENT	lstent;

    Sls3file = search_path(LSTDIR, BUSHU_SLS3);
    if (sls_open(Sls3file) != OK)
	return ERR;
    if (verbose) {
	sprintf(tmp, "$B!T%G!<%?(B=%s, $B%$%s%G%C%/%9(B=%s, $B=hM}(B=$BIt<s0lMw!U(B\n\n",
	    "$B4A;z!VBg<-@t!W(B", "$BIt<s%j%9%H(B");
	jc_outstr(tmp);
	sprintf(tmp, "%-*s\t%s\n",
	    (size_t)(slshdr.labellen), "$B8+=P$7(B", "$BIt<sHV9f(B");
	jc_outstr(tmp);
    }
    cnt = 0;
    flag = READ_FIRST;
    while (sls_readentry(flag, &p) == OK) {
	sprintf(tmp, "%-.*s\t.%d\n",
	    (size_t)(slshdr.labellen), p, cnt + 1);
	jc_outstr(tmp);
	free((char *)p);
	flag = READ_NEXT;
	cnt++;
    }
    printf("\n");
    if (verbose) {
	sprintf(tmp, "%d$B7o$N7k2L$,I=<($5$l$^$7$?(B\n\n", cnt);
	jc_outstr(tmp);
    }
    sls_close();
    return OK;
}

/*
 * printdata - $BK\J8%G!<%?A4BN$r=PNO$9$k(B
 */
int
printdata()
{
    dword	page;
    uchr	*p;

    Datfile = search_path(DATDIR, datlist[datno].datfile);
    Inffile = search_path(DATDIR, datlist[datno].inffile);
    if (dat_open(Datfile) != OK)
	return ERR;
    if (verbose) {
	sprintf(tmp, "$B!T%G!<%?(B=%s, $B=hM}(B=$BK\J8%G!<%?I=<(!U(B\n\n",
	    datlist[datno].title);
	jc_outstr(tmp);
    }
    for (page = 1; page <= dathdr.pagenum; page++) {
	if (dat_getpage(page) != OK)
	    return ERR;
	for (p = datpage; p < datpage + (int)dpagelen; p++) {
	    if (*p == 0x0d)
		*p = '\n';
	}
	while (p[-1] == '\n' && p[-2] == '\n')
	    p--;
	*p = '\0';
	jc_output(datpage);
	printf("\n");
	show_inf(page, (dword)0, datpage);
    }
    dat_close();
    return OK;
}

/*
 * dump_param - $BFbIt@_Dj>pJs$r%@%s%W$9$k(B
 */
int
dump_param()
{
    uchr	**dp;

    jc_outstr("$B!T%Q%i%a!<%?!<@_Dj!U(B\n");
    printf("%16s: %s\n", "bigendian", bigendian? "TRUE": "FALSE");
    printf("%16s: ", "kcode");
    switch (kcode) {
    case KC_JIS:
	printf("JIS%c%c\n", jiskanji, jisalpha);
	break;
    case KC_EUC:
	printf("EUC\n");
	break;
    case KC_SJIS:
	printf("SJIS\n");
	break;
    }
    printf("%16s: %s\n", "verbose", verbose? "TRUE": "FALSE");
    printf("%16s: %c\n", "debug", debug? debug: '0');
    printf("%16s: %d\n", "width", width);
    printf("%16s: %d\n", "datno", datno);
    printf("%16s: %d\n", "idxno", idxno);
    printf("%16s: %d\n", "startpage", startpage);
    printf("%16s: %d\n", "endpage", endpage);
    printf("%16s: %s\n", "mkrevidx", mkrevidx? "TRUE": "FALSE");
    printf("%16s: %d\n", "mkrevstep", mkrevstep);
    printf("%16s: %s\n", "idxonly", idxonly? "TRUE": "FALSE");
    printf("%16s: %s\n", "revidx", revidx? "TRUE": "FALSE");
    printf("%16s: %s\n", "listonly", listonly? "TRUE": "FALSE");
    printf("%16s: %s\n", "bushuonly", bushuonly? "TRUE": "FALSE");
    printf("%16s: %s\n", "printall", printall? "TRUE": "FALSE");
    printf("%16s: [%s]\n", "gaijifile", gaijifile? (char*)gaijifile: "(null)");
    if (dicpath == NULL) {
	printf("%16s: (null)\n", "dicpath");
    } else {
	for (dp = dicpath; *dp; dp++) {
	    printf("%17s ", dp == dicpath? "dicpath:": "");
	    printf("[%s]\n", *dp);
	}
    }
    printf("\n");
    return OK;
}

/*
 * debugproc - $B%G%P%C%0>pJs$NI=<((B
 */
int
debugproc(type)
int	type;
{
    switch (type) {
    case 'd':
	Datfile = search_path(DATDIR, datlist[datno].datfile);
	if (dat_open(Datfile) == OK) {
	    dat_hdrinfo();
	    dat_dumppage((dword)startpage, (dword)endpage);
	    dat_close();
	}
	break;
    case 'i':
	Datfile = search_path(DATDIR, datlist[datno].datfile);
	Inffile = search_path(DATDIR, datlist[datno].inffile);
	if (inf_open(Inffile) == OK && dat_open(Datfile) == OK) {
	    inf_hdrinfo();
	    inf_dumppage((dword)startpage, (dword)endpage);
	    inf_close();
	    dat_close();
	} 
	break;
    case 'p':
	dump_param();
	break;
    case 'g':
	dump_gaiji();
	break;
    case 'h':
	if (datno == 1) {	/* $B4A;z!VBg<-@t!W(B */
	    Nidxfile = search_path(IDXDIR, ONKUN_IDX);
	    Nlstfile = search_path(LSTDIR, ONKUN_LST);
	    Sidxfile = search_path(IDXDIR, SOKAKU_IDX);
	    Slstfile = search_path(LSTDIR, SOKAKU_LST);
	    Bidxfile = search_path(IDXDIR, BUSHU_IDX);
	    Blstfile = search_path(LSTDIR, BUSHU_LST);
	    Sls2file = search_path(LSTDIR, BUSHU_SLS2);
	    Sls3file = search_path(LSTDIR, BUSHU_SLS3);
	    jc_outstr("$B!T!T2;71%$%s%G%C%/%94XO"!U!U(B\n\n");
	    if (idx_open(Nidxfile) == OK) {
		idx_hdrinfo();
		idx_close();
	    }
	    if (lst_open(Nlstfile) == OK) {
		lst_hdrinfo();
		lst_close();
	    }
	    jc_outstr("$B!T!TAm2h?t%$%s%G%C%/%94XO"!U!U(B\n\n");
	    if (dn_open(Sidxfile) == OK) {
		dn_hdrinfo();
		dn_close();
	    }
	    if (lst_open(Slstfile) == OK) {
		lst_hdrinfo();
		lst_close();
	    }
	    jc_outstr("$B!T!TIt<s%$%s%G%C%/%94XO"!U!U(B\n\n");
	    if (dn_open(Bidxfile) == OK) {
		dn_hdrinfo();
		dn_close();
	    }
	    if (sls_open(Sls2file) == OK) {
		sls_hdrinfo();
		sls_close();
	    }
	    if (sls_open(Sls3file) == OK) {
		sls_hdrinfo();
		sls_close();
	    }
	    if (lst_open(Blstfile) == OK) {
		lst_hdrinfo();
		lst_close();
	    }
	} else {
	    Nidxfile = search_path(IDXDIR, idxlist[idxno].nidxfile);
	    Nlstfile = search_path(LSTDIR, idxlist[idxno].nlstfile);
	    Ridxfile = search_path(IDXDIR, idxlist[idxno].ridxfile);
	    Rlstfile = search_path(LSTDIR, idxlist[idxno].rlstfile);
	    if (Ridxfile != NULL)
		jc_outstr("$B!T!TA0J}0lCW%$%s%G%C%/%94XO"!U!U(B\n\n");
	    if (idx_open(Nidxfile) == OK) {
		idx_hdrinfo();
		idx_close();
	    }
	    if (lst_open(Nlstfile) == OK) {
		lst_hdrinfo();
		lst_close();
	    }
	    if (Ridxfile != NULL)
		jc_outstr("$B!T!T8eJ}0lCW%$%s%G%C%/%94XO"!U!U(B\n\n");
	    if (Ridxfile != NULL && idx_open(Ridxfile) == OK) {
		idx_hdrinfo();
		idx_close();
	    }
	    if (Rlstfile != NULL && lst_open(Rlstfile) == OK) {
		lst_hdrinfo();
		lst_close();
	    }
	}
	Datfile = search_path(DATDIR, datlist[datno].datfile);
	Inffile = search_path(DATDIR, datlist[datno].inffile);
	jc_outstr("$B!T!T%G!<%?%U%!%$%k4XO"!U!U(B\n\n");
	if (dat_open(Datfile) == OK) {
	    dat_hdrinfo();
	    dat_close();
	}
	if (inf_open(Inffile) == OK) {
	    inf_hdrinfo();
	    inf_close();
	}
	break;
    default:
	usage();
	break;
    }
    return OK;
}

/*
 * onintr - $B3d$j9~$_;~$N=*N;=hM}(B
 */
void
onintr()
{
    jc_reset();
    idx_close();
    dn_close();
    sls_close();
    lst_close();
    dat_close();
    inf_close();
    dhl_close();
    exit(0);
}

int
main(ac, av)
int	ac;
char	**av;
{
    signal(SIGINT, onintr);
    init_util();
    if (init_env() != OK)
	usage();
    ac--, av++;
    if (ac == 0)
	usage();
    while (ac > 0 && **av == '-') {
	if (parse_opt(*av) != OK)
	    usage();
	ac--, av++;
    }
    if (dicpath == NULL) {
	sprintf(tmp, "%s: $B<-=q8!:w%Q%9$,@_Dj$5$l$F$$$^$;$s(B\n", progname);
	jc_outstr(tmp);
	exit(1);
    }
    init_gaiji();
    load_gaiji();
    if (debug) {
	debugproc(debug);
    } else if (printall) {
	if (ac > 0)
	    usage();
	printdata();
    } else if (idxonly && ac == 0) {
	keylist();
    } else if (listonly && ac == 0) {
	labellist();
    } else if (bushuonly) {
	if (ac > 0)
	    usage();
	bushulist();
    } else if (mkrevidx) {
	if (ac > 0)
	    usage();
	Nidxfile = search_path(IDXDIR, MAIN_NIDX);
	Nlstfile = search_path(LSTDIR, MAIN_LST);
	Datfile = search_path(DATDIR, MAIN_DAT);
	if (mkrevstep != 2) {
	    if (idx_open(Nidxfile) != OK)
		exit(1);
	}
	if (mkrevstep == 0 || mkrevstep == 1) {
	    if (lst_open(Nlstfile) != OK || dat_open(Datfile) != OK)
		exit(1);
	}
	make_revidx(MAIN_RIDX, mkrevstep);
	if (mkrevstep != 2)
	    idx_close();
	if (mkrevstep == 0 || mkrevstep == 1) {
	    lst_close();
	    dat_close();
	}
    } else if (ac == 0) {
	usage();
    } else if (datno == 0) {	/* $BBg<-@tK\J8(B */
	Nidxfile = search_path(IDXDIR, idxlist[idxno].nidxfile);
	Ridxfile = search_path(IDXDIR, idxlist[idxno].ridxfile);
	Nlstfile = search_path(LSTDIR, idxlist[idxno].nlstfile);
	Rlstfile = search_path(LSTDIR, idxlist[idxno].rlstfile);
	Datfile = search_path(DATDIR, datlist[datno].datfile);
	Inffile = search_path(DATDIR, datlist[datno].inffile);
	while (ac > 0) {
	    if (**av >= '0' && **av <= '9')
		showpagedata(*av);
	    else
		retrieve(*av);
	    ac--, av++;
	}
    } else if (datno == 1) {	/* $B4A;z!VBg<-@t!W(B */
	Nidxfile = search_path(IDXDIR, ONKUN_IDX);
	Nlstfile = search_path(LSTDIR, ONKUN_LST);
	Sidxfile = search_path(IDXDIR, SOKAKU_IDX);
	Slstfile = search_path(LSTDIR, SOKAKU_LST);
	Bidxfile = search_path(IDXDIR, BUSHU_IDX);
	Blstfile = search_path(LSTDIR, BUSHU_LST);
	Sls2file = search_path(LSTDIR, BUSHU_SLS2);
	Sls3file = search_path(LSTDIR, BUSHU_SLS3);
	Datfile = search_path(DATDIR, KANJI_DAT);
	Inffile = search_path(DATDIR, KANJI_INF);
	while (ac > 0) {
	    if (**av >= '0' && **av <= '9')
		showpagedata(*av);
	    else
		knj_retrieve(*av);
	    ac--, av++;
	}
    } else {
	usage();
    }
    exit(0);
}
